DEFINITION MODULE AssFuncs;

FROM SYSTEM IMPORT ADDRESS;

IMPORT MagicStrings;

(* Fr Editbase *)
PROCEDURE findLineEnd (buf : ADDRESS; startIdx : LONGCARD; max : LONGCARD) : LONGCARD;

(* Fr Case-Insensitive Stringvergleiche *)
PROCEDURE StrIequal (REF s1, s2 : ARRAY OF CHAR): BOOLEAN;

PROCEDURE StrICompare (REF str0,str1: ARRAY OF CHAR) : MagicStrings.Relation;

PROCEDURE CopyId (REF source: ARRAY OF CHAR; VAR dest: ARRAY OF CHAR): CARDINAL;
(* Kopiert eine ID, wandelt dabei den domain-part (alles nach @) in Upcase
 * und liefert die Lnge zurck
 *)

PROCEDURE CmpId (REF str1, str2 : ARRAY OF CHAR): BOOLEAN;
(* Vergleicht zwei IDs miteinander, wobei der domain-part case-insensitiv
 * behandelt wird.
 *)

PROCEDURE WandleIso (str: ADDRESS; strLen: CARDINAL);
(* Wandelt den String von ISO-8859-1 nach ST-Zeichensatz um
 *)

END AssFuncs.

