DEFINITION MODULE CatHelp;

IMPORT Lists;

TYPE    tHelp = (general, catinfo, editor, grin, manager, msglist, 
                 treelist, formats, 
                 paths, allgconf, tauschconf, listconf, searchdial, 
                 smallsearch, filter, groupsel, groupRead, groupWrite, 
                 groupUser, infoRead, infoEdit, oversize, selectGroup, 
                 reghelp, wvhelp, textsearch, textrepl, changemsg,
                 itkhelp, configInfile, confEdit, iofilter);

PROCEDURE DoHelp (topic: tHelp);

PROCEDURE DoExternalHelp (VAR helpList: Lists.List);
(* Es wird eine Liste bergeben, die in der Hilfedialogbox
 * angezeigt wird. Die Liste besteht aus Zeigern auf einzelne
 * Strings, wobei jeder String nicht lnger als 65 Zeichen sein
 * darf. Die Liste wird am Ende automatisch dealloziert,
 * ist also nicht mehr benutzbar
 *)

END CatHelp.
