DEFINITION MODULE CatTypes;

(*$S-,R-*)

CONST CatVersion = '3.03 ';
      CatDate    = '24.10.1997';

CONST scrapFile = 'scrap.txt'; (* Das ist im Moment das einzige, das Cat versteht *)
      rawClip   = 'x:\CLIPBRD\';

      statusInf = 'status.inf';
      grSelect  = 'grselect.inf';
      userCmdFile  = 'catcmds.inf';

      headerExt = '.hdr';
      textExt   = '.txt';

      (* Defaults fr Stichwortlistenzeilen *)
      cPrivateDefault    = 'D(12),M(10),U(30),W(30),S(2)';
      cGlobalDefault     = 'D(12),M(10),U(30),W(30),C(2),S(2)';


TYPE String1023  = ARRAY[0..1023] OF CHAR;
     Str1023Ptr  = POINTER TO String1023;

     String255   = ARRAY[0..255] OF CHAR;
     Str255Ptr   = POINTER TO String255;

     String127   = ARRAY[0..127] OF CHAR;
     Str127Ptr   = POINTER TO String127;
     
     BigText     = ARRAY[0..MAX(CARDINAL)] OF CHAR;
     BigTextPtr  = POINTER TO BigText;

     LargeText   = ARRAY[0..MAX(LONGCARD)] OF CHAR;
     LargeTextPtr= POINTER TO LargeText;

     DateType    = ARRAY[0..18] OF CHAR;  (* Datum aus der Datenbank *)

     pathStrType = ARRAY[0..255] OF CHAR; (* Fr Pfade *)
     nameStrType = ARRAY[0..40] OF CHAR;  (* Fr Filenamen *)
     extStrType  = ARRAY[0..3] OF CHAR;   (* Fr Extensions *)

TYPE xywhType    = RECORD x,y,w,h : INTEGER END;

TYPE charSet = SET OF CHAR;

TYPE Trick =  POINTER TO RECORD
                CASE : BOOLEAN OF
                  TRUE:  wert: INTEGER;|
                  FALSE: hi: CHAR;
                         lo: CHAR;|
                END;
              END;

TYPE  m7VerRecord = RECORD
                        major   : INTEGER;
                        minor   : INTEGER;
                        str     : ARRAY[0..39] OF CHAR;
                    END;
                    
END CatTypes.
