IMPLEMENTATION MODULE Find2;


FROM SYSTEM IMPORT ADDRESS, ASSEMBLER, TSIZE;
IMPORT Char, Storage;

 CONST
  TSizeTPattern = TSIZE (tPattern);
  xyz = 20;

(*
;: (* (c) 3/1992 Andreas Alich *)

;: FROM Find2 IMPORT
;:  tPattern AS tPattern_,
;:  tPat AS tPat_;
;: CONST
;:  TSIZE_tPattern = TSIZE (tPattern);
;.
*)

(* __optimize set TRUE *)

 PROCEDURE Compile (VAR pattern: ARRAY OF CHAR; any, all, all_but_eol, eol: CHAR;
          cap, backward: BOOLEAN): tpPattern;

(* PREFIX com_;
 REG
    D2/
    D3/ (* * (all_but_eol) *)
    D4/ (* Anfang des Teilmusters *)
    D5/ (* 1 + Position des letzten/ersten ?, das nicht an
         letzter/erster Stelle steht *)
    D6/ (* ? (any) *)
    D7/ (* @ (all) *)
    A2/ (* aktuelles Pat *)
    A3/
    A4/
    A5; (* Adresse des Nachfolgerzeigers *)
 LINK A6;
*)
 VAR
    pPattern: tpPattern;
    pEnd: ADDRESS;
    regA3 : ADDRESS;

   BEGIN (* PROC Compile *)
    ASSEMBLER
    MOVEM.L   D0-A6,-(A7)
    MOVE.L  A3,regA3(A6)

com_0:
    LEA     pPattern(A6),A0
    MOVEM.L D0-A6,-(SP)
    MOVE.L  A0,(A3)+
    MOVE.L  #TSizeTPattern,(A3)+
    JSR     Storage.ALLOCATE
    MOVEM.L (SP)+,D0-A6

    MOVEA.L pPattern(A6),A0

    CLR.L   tPattern.pFirst(A0)
    CLR.L   tPattern.pLast(A0)
    MOVE.B  any(A6),D6
    MOVE.B  D6,tPattern.any(A0)
    MOVE.B  all(A6),D7
    MOVE.B  all_but_eol(A6),D3
    MOVE.W  backward(A6),tPattern.backward(A0)
    LEA     tPattern.pFirst(A0),A5
    SUBA.L  A2,A2       ;Initialisierung, falls Muster leer
    MOVE.L  pattern(A6),pEnd(A6)
com_1:
    MOVE.L  pEnd(A6),A0
    MOVEQ   #NIL,D5
com_2:
    MOVE.B  (A0)+,D0
    CMP.B   D0,D7
    BEQ.S   com_2       ;fhrende @ ...
    CMP.B   D0,D3
    BEQ.S   com_2       ;... und * berlesen
    SUBQ.W  #1,A0
    MOVE.L  A0,D4
com_4:
    MOVE.B  (A0)+,D0
    BEQ.S   com_8
    CMP.B   D0,D7       ;@
    BEQ.S   com_8
    CMP.B   D0,D3       ;*
    BNE.S   com_4
com_8:
    SUBQ.W  #1,A0
    MOVE.L  A0,pEnd(A6);Position des Trennsymbols (@/*/0C)
    SUBA.L  D4,A0       ;Teilmusterlnge
    MOVE.W  A0,D2
    BEQ.W   com_30      ;leeres Muster
    
;   PEA     tPat.pattern+1(A0)  ;Rec.gre bis pattern + Musterlnge+1
    MOVEM.L D0-A6,-(SP)
    MOVE.L  regA3(A6),A3
    MOVE.L  A5,(A3)+
    LEA     tPat.pattern+1(A0),A1
    MOVE.L  A1,(A3)+
    JSR     Storage.ALLOCATE
    MOVEM.L (SP)+,D0-A6
    
    MOVEA.L (A5),A2
    CLR.L   tPat.pPrev(A2)
    CLR.L   tPat.pNext(A2)
    MOVE.W  D2,tPat.len(A2)
    MOVE.B  eol(A6),tPat.eol(A2)
    CLR.W   tPat.idx(A2)
    LEA     tPat.pNext(A2),A5

    LEA     tPat.pattern(A2),A3
    TST.W   backward(A6)
    BNE.S   com_62
    CLR.B   (A3)+
com_62:
    TST.W   cap(A6)
    BNE.S   com_65
    MOVE.W  D2,D1
    SUBQ.W  #1,D1
    MOVEA.L D4,A0
com_61:
    MOVE.B  (A0)+,(A3)+
    DBRA    D1,com_61
    BRA.S   com_69
com_65:
    JSR     Char.pUpper/
    MOVEA.L D0,A4

    MOVE.W  D2,D1
    SUBQ.W  #1,D1
    MOVEA.L D4,A0
    MOVEQ   #0,D0
com_66:
    MOVE.B  (A0)+,D0
    CMP.B   D0,D6       ;?
    BEQ.S   com_67
    MOVE.B  0(A4,D0.W),D0    ;Cap
com_67:
    MOVE.B  D0,(A3)+
    DBRA    D1,com_66
com_69:
    TST.W   backward(A6)
    BEQ.S   com_63
    CLR.B   (A3)+
com_63:
    MOVE.L  pEnd(A6),A0
    CMP.B   (A0),D3     ;* als Trennsymbol
    SEQ     tPat.no_eol(A2)
    TST.W   backward(A6)
    BNE.W   com_40

    MOVEQ   #4,D1
    LEA     tPat.pattern+1(A2),A1 ;(fhrendes 0C!)
    CMP.B   -1(A1,D2.W),D6  ;letztes Zeichen mit ? vgl.
    BNE.S   com_19
    MOVE.W  D1,tPat.idx(A2) ;Muster enthlt ?
com_19:
    MOVE.W  D2,D0
    SUBQ.W  #2,D0
    BMI.S   com_21      ;Musterlnge 1
; Untersuchung der ersten n-1 Zeichen
com_11:
    CMP.B   (A1)+,D6        ;?
    BNE.S   com_17
    MOVE.L  A1,D5       ;Position des (letzten) ? merken
    MOVE.W  D1,tPat.idx(A2) ;Muster enthlt ?
com_17:
    DBRA    D0,com_11
com_21:
    TST.L   D5
    BEQ.S   com_10      ;kein ?
    LEA     tPat.pattern+1(A2),A0 ;(fhrendes 0C!)
    ADDA.W  D2,A0
    SUBA.L  D5,A0       ;#Zeichen nach ?
    MOVE.W  A0,D2
com_10:
    MOVE.B  D2,D1
    LSL.W   #8,D1
    MOVE.B  D2,D1
    MOVE.W  D1,D0
    SWAP    D1
    MOVE.W  D0,D1
    MOVEQ   #15,D0
    LEA     tPat.d(A2),A0
com_12:
    MOVE.L  D1,(A0)+
    MOVE.L  D1,(A0)+
    MOVE.L  D1,(A0)+
    MOVE.L  D1,(A0)+
    DBRA    D0,com_12

    SUBQ.W  #1,D2
    BNE.S   com_13      ;(relevante) Musterlnge > 1
    TST.W   cap(A6)
    BEQ     com_1
    ADDQ.W  #2,tPat.idx(A2) ;gro/klein beim Vgl. ignorieren
    BRA     com_1
com_13:
    LEA     tPat.pattern+1(A2),A1 ;(fhrendes 0C!)
    MOVE.L  D5,D0
    BEQ.S   com_14
; Zeichen bis zum letzten ? verndern d nicht
    MOVEA.L D5,A1
com_14:
    LEA     tPat.d(A2),A3
    TST.W   cap(A6)
    BNE.S   com_20
; d gem den Zeichen nach dem letzten ? anpassen
    MOVEQ   #0,D0
com_16:
    MOVE.B  (A1)+,D0
    MOVE.B  D2,0(A3,D0.W)
    SUBQ.B  #1,D2
    BNE.S   com_16
    BRA     com_1

com_20:
    ADDQ.W  #2,tPat.idx(A2) ;gro/klein beim Vgl. ignorieren
    MOVE.L  A1,-(A7)
    JSR     Char.pLower/
    MOVEA.L D0,A4
    MOVE.L  (A7)+,A1

    MOVEQ   #0,D0
; d gem den Zeichen nach dem letzten ? anpassen
com_26:
    MOVE.B  (A1)+,D0        ;bereits Cap
    MOVE.B  D2,0(A3,D0.W)
    MOVE.B  0(A4,D0.W),D0    ;Lower
    MOVE.B  D2,0(A3,D0.W)
    SUBQ.B  #1,D2
    BNE.S   com_26
    BRA     com_1


com_40:
; Rckwrtssuche
    MOVEQ   #4,D1
    LEA     tPat.pattern(A2),A1
    CMP.B   (A1),D6     ;erstes Zeichen mit ? vgl.
    BNE.S   com_43
    MOVE.W  D1,tPat.idx(A2) ;Muster enthlt ?
com_43:
    MOVE.W  D2,D0
    SUBQ.W  #2,D0
    BMI.S   com_48      ;Musterlnge 1
; Untersuchung der letzten n-1 Zeichen
    ADDA.W  D2,A1
com_41:
    CMP.B   -(A1),D6        ;?
    BNE.S   com_47
    MOVE.L  A1,D5       ;Position des (ersten) ? merken
    MOVE.W  D1,tPat.idx(A2) ;Muster enthlt ?
com_47:
    DBRA    D0,com_41
com_48:
    TST.L   D5
    BEQ.S   com_49      ;kein ?
    MOVE.L  D5,D2
    LEA     tPat.pattern(A2),A0
    SUB.L   A0,D2       ;#Zeichen vor ?
com_49:
    MOVE.B  D2,D1
    LSL.W   #8,D1
    MOVE.B  D2,D1
    MOVE.W  D1,D0
    SWAP    D1
    MOVE.W  D0,D1
    MOVEQ   #15,D0
    LEA     tPat.d(A2),A0
com_42:
    MOVE.L  D1,(A0)+
    MOVE.L  D1,(A0)+
    MOVE.L  D1,(A0)+
    MOVE.L  D1,(A0)+
    DBRA    D0,com_42

    SUBQ.W  #1,D2
    BNE.S   com_45      ;(relevante) Musterlnge > 1
    TST.W   cap(A6)
    BEQ     com_1
    ADDQ.W  #2,tPat.idx(A2) ;gro/klein beim Vgl. ignorieren
    BRA     com_1
com_45:
    LEA     tPat.pattern+1(A2),A1 ;(D2 wurde um 1 verringert)
    ADDA.W  D2,A1
    LEA     tPat.d(A2),A3
    TST.W   cap(A6)
    BNE.S   com_50
; d gem den Zeichen vor dem ersten ? anpassen
    MOVEQ   #0,D0
com_46:
    MOVE.B  -(A1),D0
    MOVE.B  D2,0(A3,D0.W)
    SUBQ.B  #1,D2
    BNE.S   com_46
    BRA     com_1

com_50:
    ADDQ.W  #2,tPat.idx(A2) ;gro/klein beim Vgl. ignorieren
    MOVE.L  A1,-(A7)
    JSR     Char.pLower/
    MOVEA.L D0,A4
    MOVE.L  (A7)+,A1

    MOVEQ   #0,D0
; d gem den Zeichen vor dem ersten ? anpassen
com_56:
    MOVE.B  -(A1),D0        ;bereits Cap
    MOVE.B  D2,0(A3,D0.W)
    MOVE.B  0(A4,D0.W),D0    ;Lower
    MOVE.B  D2,0(A3,D0.W)
    SUBQ.B  #1,D2
    BNE.S   com_56
    BRA     com_1


com_30:
; Rckwrtsverkettung erstellen
    MOVE.L  pPattern(A6),A0
    MOVE.L  A2,tPattern.pLast(A0)   ;ggf. NIL
    MOVE.L  tPattern.pFirst(A0),D0
    BEQ.S   com_35          ;kein Pat vorhanden
    MOVEA.L D0,A0
com_32:
    MOVE.L  tPat.pNext(A0),D0
    BEQ.S   com_34
    MOVEA.L D0,A1
    MOVE.L  A0,tPat.pPrev(A1)
    MOVE.L  A1,A0
    BRA.S   com_32
com_35:
    LEA     tPattern.pFirst(A0),A1

    MOVEM.L D0-A6,-(SP)
    MOVE.L  regA3(A6),A3
    MOVE.L  A1,(A3)+                    ; Adresse von pFirst
    MOVE.W  tPat.len(A2),D0
    EXT.L   D0
    ADDQ.L  #2,D0
    MOVE.L  D0,(A3)+                    ; Lnge berechnen 
    MOVEM.L A0-A6,-(A7)
    JSR     Storage.ALLOCATE
    MOVEM.L (SP)+,D0-A6

;    PEA     (tPat.len+2).W
;    MOVEA.L A0,A3
;    PEA tPattern_pFirst(A3)
;    CALL    Storage.ALLOCATE

    MOVEA.L tPattern.pFirst(A0),A2
    CLR.L   tPat.pPrev(A2)
    CLR.L   tPat.pNext(A2)
    CLR.W   tPat.len(A2)
    MOVE.L  A2,tPattern.pLast(A3)
com_34:
    MOVE.L  pPattern(A6),D0
com_ret:
    MOVEM.L (A7)+,D0-A6
    
    ; Sprungtabellen initialisieren: 
    CLR.L   (A3)+
    CLR.L   (A3)+
    CLR.L   (A3)+
    CLR.L   (A3)+
    JSR     Find/
    END;
    RETURN pPattern
   END (*PROC*)  Compile;


PROCEDURE Find (Text: ADDRESS; (* Anfangsadresse des zu durchsuchenden Textes *)
          TextLen: LONGINT; (* Gesamtlnge des Textes *)
          p: tpPattern; (* Zeiger auf vorcompiliertes Suchmuster *)
          Start: LONGINT (* Such-Startposition im Text *)
          ): BOOLEAN;


(*
;: PREFIX f_;
;: REG
;:  D2/
;:  D3/ (* (any) *)
;:  D4/ (* Null *)
;:  D6/ (* pPatternEnd *)
;:  D7/ (* pEnd *)
;:  A2/ (* (pMatch) *)
;:  A3/ (* d *)
;:  A4/ (* Cap *)
;:  A5/ (* pPat *)
;:  A6; (* Cmp *)
;.
*) VAR erg : BOOLEAN;
   BEGIN (*PROC Find *)
   ASSEMBLER
    MOVEM.L D0-A6,-(A7)

    MOVE.L  p(A6),A2
    CMPA.L  #0,A2
    BEQ.W   f_init
    MOVE.L  tPattern.pFirst(A2),D0
    MOVEA.L D0,A0
    TST.W   tPat.len(A0)
    BNE.S   f_1
; leeres Muster
    MOVE.L  Text(A6),D0
    BEQ.W   f_false
    ADD.L   Start(A6),D0
    MOVE.L  D0,tPat.pMatch(A0)
    BRA.W   f_true
f_1:
    MOVE.L  Text(A6),A1
    MOVE.L  A1,D7
    TST.W   tPattern.backward(A2)
    BNE.W   fb_1

    MOVE.L  Start(A6),D2
    ADDA.L  D2,A1       ;Startposition im Text
    MOVE.L  A1,D3
ff_0:
    MOVEA.L D0,A0
    ADDA.W  tPat.len(A0),A1
    MOVE.L  A1,tPat.pMatch(A0)  ;zunchst Zeiger hinter Match
    MOVE.L  tPat.pNext(A0),D0
    BNE.S   ff_0

    MOVE.L  TextLen(A6),D1
    ADD.L   D1,D7
    SUB.L   D2,D1       ;Textlnge ab Suchstart
    BLE.W   f_false
    SUBA.L  D3,A1       ;Gesamtlnge der Teilmuster
    CMPA.L  D1,A1
    BGT.W   f_false     ;Muster lnger als Rest des Textes

    MOVEQ   #0,D4
    MOVE.B  tPattern.any(A2),D3
    JSR     Char.pUpper/
    MOVEA.L D0,A4
    MOVE.L  tPattern.pLast(A2),A5
    MOVE.L  D7,tPat.pLimit(A5)
    MOVEQ   #0,D1
ff_3:
    MOVEA.L tPat.pMatch(A5),A2
    LEA     tPat.d(A5),A3
    MOVE.L  tPat.pLimit(A5),D7
    TST.B   D1
    BEQ.S   ff_2
    MOVE.L  D7,A0
    MOVE.B  tPat.eol(A5),D0
ff_4:
    CMP.B   -(A0),D0
    BEQ.S   ff_5
    CMPA.L  A2,A0
    BHI.S   ff_4
    BRA.S   ff_2
ff_5:
    LEA 1(A0),A2
ff_2:
    LEA     tPat.pattern-1(A5),A0
    ADDA.W  tPat.len(A5),A0
    MOVE.L  A0,D6
    ADDQ.L  #2,D6
;alt: 
;    LEA     fcmpTable(PC),A0
;    MOVE.W  tPat.idx(A5),D0
;    ADDA.W  (A0,D0.W),A0
    LEA     fcmpTable(PC),A0
    MOVE.W  tPat.idx(A5),D0
    LSL.W   #1,D0
    ADDA.W  D0,A0
    MOVE.L  (A0),A0
    JMP     (A0)

ff_7:
; keine bereinstimmung
    MOVE.L  tPat.pNext(A5),D0
    BEQ.S   f_false     ;kein Nachfolger -> Suche erfolglos
    MOVEA.L D0,A5
    MOVEA.L tPat.pMatch(A5),A2
    LEA     tPat.d(A5),A3
    MOVE.L  tPat.pLimit(A5),D7
    MOVE.B  -1(A2),D4
    MOVE.B  0(A3,D4.W),D4
    ADDA.W  D4,A2
    CMPA.L  D7,A2
    BHI.S   ff_7
    BRA.S   ff_2        ;Suche mit Nachfolger fortsetzen
ff_6:
; bereinstimmung
    MOVE.L  A2,tPat.pMatch(A5)
    MOVE.L  tPat.pPrev(A5),D0
    BEQ.S   ff_10       ;Alle Teilmuster passen
    MOVEA.L A2,A0
    SUBA.W  tPat.len(A5),A0
    MOVE.L  D0,A5
    MOVE.B  tPat.no_eol(A5),D1
    MOVE.L  A0,tPat.pLimit(A5)
    BRA.S   ff_3        ;Suche mit Vorgnger fortsetzen
ff_10:
    MOVEQ   #0,D1
; pMatch-Zeiger jeweils auf den Anfang des gef. Teilmusters setzen
ff_11:
    MOVE.W  tPat.len(A5),D1
    SUB.L   D1,tPat.pMatch(A5)
    MOVE.L  tPat.pNext(A5),D0
    BEQ.W   f_true
    MOVEA.L D0,A5
    BRA.S   ff_11

f_false:
    MOVE.W  #FALSE,erg(A6)
    BRA.W   f_endproc
f_true:
    MOVE.W  #TRUE,erg(A6)
f_ret:
    BRA.W   f_endproc;

f_init:
   (* Init der Sprungtabellen: *)
    LEA     fcmpTable(PC),A0
    LEA     Fwd(PC),A1
    MOVE.L  A1,(A0)+
    LEA     FwdCap(PC),A1
    MOVE.L  A1,(A0)+
    LEA     FwdAny(PC),A1
    MOVE.L  A1,(A0)+
    LEA     FwdCapAny(PC),A1
    MOVE.L  A1,(A0)+
    LEA     bcmpTable(PC),A0
    LEA     Bwd(PC),A1
    MOVE.L  A1,(A0)+
    LEA     BwdCap(PC),A1
    MOVE.L  A1,(A0)+
    LEA     BwdAny(PC),A1
    MOVE.L  A1,(A0)+
    LEA     BwdCapAny(PC),A1
    MOVE.L  A1,(A0)+

    MOVE.W  #FALSE,erg(A6)
    BRA.W   f_endproc
    
Fwd:
ff_14:
    MOVEA.L A2,A0       ;Text
    MOVEA.L D6,A1       ;Muster
ff_15:
    MOVE.B  -(A1),D0
    BEQ.W   ff_6        ;Muster stimmt mit Text berein
    CMP.B   -(A0),D0
    BEQ.S   ff_15
    MOVE.B  -1(A2),D4
    MOVE.B  0(A3,D4.W),D4
    ADDA.W  D4,A2
    CMPA.L  D7,A2
    BLS.S   ff_14
    BRA.W   ff_7

FwdCap:
ff_24:
    MOVEA.L A2,A0       ;Text
    MOVEA.L D6,A1       ;Muster
ff_25:
    MOVE.B  -(A1),D0
    BEQ.W   ff_6        ;Muster stimmt mit Text berein
    MOVE.B  -(A0),D4
    CMP.B   0(A4,D4.W),D0
    BEQ.S   ff_25
    MOVE.B  -1(A2),D4
    MOVE.B  0(A3,D4.W),D4
    ADDA.W  D4,A2
    CMPA.L  D7,A2
    BLS.S   ff_24
    BRA ff_7

FwdAny:
ff_34:
    MOVEA.L A2,A0       ;Text
    MOVEA.L D6,A1       ;Muster
ff_35:
    MOVE.B  -(A1),D0
    BEQ ff_6        ;Muster stimmt mit Text berein
    CMP.B   D0,D3
    BEQ.S   ff_36       ;?
    CMP.B   -(A0),D0
    BEQ.S   ff_35
    MOVE.B  -1(A2),D4
    MOVE.B  0(A3,D4.W),D4
    ADDA.W  D4,A2
    CMPA.L  D7,A2
    BLS.S   ff_34
    BRA ff_7
ff_36:
    SUBQ.W  #1,A0
    BRA.S   ff_35

FwdCapAny:
ff_44:
    MOVEA.L A2,A0       ;Text
    MOVEA.L D6,A1       ;Muster
ff_45:
    MOVE.B  -(A1),D0
    BEQ ff_6        ;Muster stimmt mit Text berein
    MOVE.B  -(A0),D4
    CMP.B   D0,D3
    BEQ.S   ff_45       ;?
    CMP.B   0(A4,D4.W),D0
    BEQ.S   ff_45
    MOVE.B  -1(A2),D4
    MOVE.B  0(A3,D4.W),D4
    ADDA.W  D4,A2
    CMPA.L  D7,A2
    BLS.S   ff_44
    BRA ff_7


;*---------------------------------------
fb_1:
    MOVE.L  Start(A6),D2
    BMI     f_false     ;neg. Startposition

    MOVEA.L TextLen(A6),A3
fb_8:
    MOVEA.L D0,A0
    SUBA.W  tPat.len(A0),A3
    MOVE.L  tPat.pNext(A0),D0
    BNE.S   fb_8

    CMP.L   A3,D2
    BLE.S   fb_9
; Startposition nach unten korrigieren (Muster lnger als Rest)
    MOVE.L  A3,D2
    BMI     f_false     ;neg. Startposition
fb_9:
    ADDA.L  D2,A1       ;Startposition im Text
    MOVE.L  A1,D3
    MOVE.L  tPattern.pFirst(A2),D0
fb_0:
    MOVEA.L D0,A0
    MOVE.L  A1,tPat.pMatch(A0)  ;Zeiger auf Match
    ADDA.W  tPat.len(A0),A1
    MOVE.L  tPat.pNext(A0),D0
    BNE.S   fb_0

    MOVEQ   #0,D4
    MOVE.B  tPattern.any(A2),D3
    JSR     Char.pUpper/
    MOVEA.L D0,A4
    MOVE.L  tPattern.pFirst(A2),A5
    MOVE.L  D7,tPat.pLimit(A5)
    MOVEQ   #0,D1
fb_3:
    MOVEA.L tPat.pMatch(A5),A2
    LEA     tPat.d(A5),A3
    MOVE.L  tPat.pLimit(A5),D7
    TST.B   D1
    BEQ.S   fb_2
    MOVE.L  D7,A0
    MOVE.B  tPat.eol(A5),D0
fb_4:
    CMP.B   (A0)+,D0
    BEQ.S   fb_5
    CMPA.L  A2,A0
;    BLO.S   fb_4
    BCS.S   fb_4
    BRA.S   fb_2
fb_5:
    LEA -1(A0),A2
fb_2:
    LEA     tPat.pattern(A5),A0
    MOVE.L  A0,D6
    ADDA.W  tPat.len(A5),A0
;    LEA     bcmpTable(PC),A0
;    MOVE.W  tPat.idx(A5),D0
;    ADDA.W  (A0,D0.W),A0

    LEA     bcmpTable(PC),A0
    MOVE.W  tPat.idx(A5),D0
    LSL.W   #1,D0
    ADDA.W  D0,A0
    MOVE.L  (A0),A0
    JMP     (A0)

fb_7:
; keine bereinstimmung
    MOVE.L  tPat.pPrev(A5),D0
    BEQ     f_false     ;kein Vorgnger -> Suche erfolglos
    MOVEA.L D0,A5
    MOVEA.L tPat.pMatch(A5),A2
    LEA     tPat.d(A5),A3
    MOVE.L  tPat.pLimit(A5),D7
    MOVE.B  (A2),D4
    MOVE.B  0(A3,D4.W),D4
    SUBA.W  D4,A2
    CMPA.L  D7,A2
;    BLO.S   fb_7
    BCS.S   fb_7
    BRA.S   fb_2        ;Suche mit Vorgnger fortsetzen
fb_6:
; bereinstimmung
    MOVE.L  A2,tPat.pMatch(A5)
    MOVE.L  tPat.pNext(A5),D0
    BEQ     f_true      ;Alle Teilmuster passen
    MOVEA.L A2,A0
    ADDA.W  tPat.len(A5),A0
    MOVE.B  tPat.no_eol(A5),D1
    MOVE.L  D0,A5
    MOVE.L  A0,tPat.pLimit(A5)
    BRA.S   fb_3        ;Suche mit Nachfolger fortsetzen

Bwd:
fb_14:
    MOVEA.L A2,A0       ;Text
    MOVEA.L D6,A1       ;Muster
fb_15:
    MOVE.B  (A1)+,D0
    BEQ.S   fb_6        ;Muster stimmt mit Text berein
    CMP.B   (A0)+,D0
    BEQ.S   fb_15
    MOVE.B  (A2),D4
    MOVE.B  0(A3,D4.W),D4
    SUBA.W  D4,A2
    CMPA.L   D7,A2
;    BHS.S   fb_14
    BCC.S   fb_14
    BRA.S   fb_7

BwdCap:
fb_24:
    MOVEA.L A2,A0       ;Text
    MOVEA.L D6,A1       ;Muster
fb_25:
    MOVE.B  (A1)+,D0
    BEQ.S   fb_6        ;Muster stimmt mit Text berein
    MOVE.B  (A0)+,D4
    CMP.B   0(A4,D4.W),D0
    BEQ.S   fb_25
    MOVE.B  (A2),D4
    MOVE.B  0(A3,D4.W),D4
    SUBA.W  D4,A2
    CMPA.L  D7,A2
;    bhs.S   fb_24
    BCC.S   fb_24
    BRA fb_7

BwdAny:
fb_34:
    MOVEA.L A2,A0       ;Text
    MOVEA.L D6,A1       ;Muster
fb_35:
    MOVE.B  (A1)+,D0
    BEQ fb_6        ;Muster stimmt mit Text berein
    CMP.B   D0,D3
    BEQ.S   fb_36       ;?
    CMP.B   (A0)+,D0
    BEQ.S   fb_35
    MOVE.B  (A2),D4
    MOVE.B  0(A3,D4.W),D4
    SUBA.W  D4,A2
    CMPA.L  D7,A2
;    bhs.S   fb_34
    BCC.S   fb_34
    BRA     fb_7
fb_36:
    ADDQ.W  #1,A0
    BRA.S   fb_35

BwdCapAny:
fb_44:
    MOVEA.L A2,A0       ;Text
    MOVEA.L D6,A1       ;Muster
fb_45:
    MOVE.B  (A1)+,D0
    BEQ fb_6        ;Muster stimmt mit Text berein
    MOVE.B  (A0)+,D4
    CMP.B   D0,D3
    BEQ.S   fb_45       ;?
    CMP.B   0(A4,D4.W),D0
    BEQ.S   fb_45
    MOVE.B  (A2),D4
    MOVE.B  0(A3,D4.W),D4
    SUBA.W  D4,A2
    CMPA.L  D7,A2
;    bhs.S   fb_44
    BCC.S   fb_44
    BRA fb_7

(*
Original:
fcmpTable:
    DC.W Fwd-fcmp_table
    DC.W FwdCap-fcmp_table
    DC.W FwdAny-fcmp_table
    DC.W FwdCapAny-fcmp_table
bcmpTable:
    DC.W Bwd-bcmp_table
    DC.W BwdCap-bcmp_table
    DC.W BwdAny-bcmp_table
    DC.W BwdCapAny-bcmp_table

Neu:
fcmpTable:
    DC.L Fwd(PC)
    DC.L FwdCap(PC)
    DC.L FwdAny(PC)
    DC.L FwdCapAny(PC)
bcmpTable:
    DC.L Bwd(PC)
    DC.L BwdCap(PC)
    DC.L BwdAny(PC)
    DC.L BwdCapAny(PC)
*)
fcmpTable:
    DC.L 0,0,0,0
bcmpTable:
    DC.L 0,0,0,0

f_endproc:
    MOVEM.L (A7)+,D0-A6
    END;
    RETURN erg
   END (*PROC *) Find;


PROCEDURE Dispose (VAR pPattern: tpPattern);
(*
;: PREFIX dis_;
;: REG A2;
;: LINK A6
*)
 VAR
    pPat: tpPat;


   BEGIN (* PROC Dispose *)
    ASSEMBLER
    MOVE.L  pPattern(A6),A0
    TST.L   (A0)
    BEQ.S   dis_5
    MOVE.L  (A0),A0
    MOVE.L  tPattern.pFirst(A0),A2
dis_0:
    MOVE.L  A2,pPat(A6)
    BEQ.S   dis_3
    MOVE.L  tPat.pNext(A2),A2
    LEA     pPat(A6),A0
    MOVE.L  A2,-(SP)
    MOVE.L  A0,(A3)+
    CLR.L   (A3)+
    JSR     Storage.DEALLOCATE
    MOVE.L  (SP)+,A2
    
;    PEA     dis_pPat(A6)
;    CALL    Storage.Free
    BRA.S   dis_0
dis_3:
    MOVE.L  pPattern(A6),(A3)+
    CLR.L   (A3)+
    JSR     Storage.DEALLOCATE
;    push.L  dis_pPattern(dis_par)
;    CALL    Storage.Free
dis_5:
    END;
   END (* PROC *) Dispose;


END Find2.                                        
   

