DEFINITION MODULE InstRsc;

FROM SYSTEM IMPORT ADDRESS;

FROM GrafBase   IMPORT Rectangle;
     
FROM MagicAES   IMPORT
     OBJECT, BITBLK, ICONBLK, TEDINFO;

FROM Strings    IMPORT String;

FROM Lists      IMPORT List;

(* Versionsnummer *)
CONST   xVersion = '1.01';
        version = 'CAT 3.0 Installer V '+xVersion+0c;

(* GEM-Handling: consts and types *)
CONST   Root            = 0;
        MaxDepth        = 999;

TYPE    PtrObjTree      = POINTER TO ARRAY [0..MaxCard] OF OBJECT;
        MaxStr          = ARRAY [0..255] OF CHAR;
        PtrMaxStr       = POINTER TO MaxStr;
        PtrBitBlock     = POINTER TO BITBLK;
        PtrIconBlock    = POINTER TO ICONBLK;
        PtrTedInfo      = POINTER TO TEDINFO;
        TwoRects        = ARRAY[0..1] OF Rectangle;

VAR     
        infoBox,
        pathbox,
        helppath,

        menu           : PtrObjTree;

        deskSize       : Rectangle;
        
        homePath       : MaxStr;

PROCEDURE InitResource (VAR resourceName : ARRAY OF CHAR) : BOOLEAN;
  
PROCEDURE doInfo();

PROCEDURE ClrRsrc();

PROCEDURE doConfig(REF newPath: ARRAY OF CHAR; VAR newDataPath: ARRAY OF CHAR);

PROCEDURE GetAndCreatePath (VAR path, name : ARRAY OF CHAR; 
                            REF title: ARRAY OF CHAR): BOOLEAN;

END InstRsc.
