DEFINITION MODULE ListUtils;

FROM mtUtils    IMPORT tRect;
FROM SYSTEM     IMPORT ADDRESS;


TYPE
        tPoint          = RECORD
                            x: INTEGER;
                            y: INTEGER;
                          END;
                  
TYPE    TwoRects        = ARRAY[0..1] OF tRect;

PROCEDURE WordArray (VAR r1, r2 : tRect) : TwoRects;

PROCEDURE FrameRects (r1, r2: tRect): tRect;
 
PROCEDURE DiffVertRect (r1, r2 : tRect) : tRect;
(* liefert das Rechteck aus r1, das nicht von r2 berdeckt wird 
 *)

PROCEDURE CalcAbsArea (tree : ADDRESS; obj: INTEGER; VAR r : tRect);

(* slider Routinen *)

PROCEDURE formSetSlider (dial: ADDRESS;
                         parent, slider : INTEGER;
                         dir : INTEGER;
                         maxVal, currentVal : LONGINT;
                         draw : BOOLEAN);

END ListUtils.
