IMPLEMENTATION MODULE UserInformation;

(*$R-, S-, M- *)

FROM MTPaths    IMPORT DataPath;
FROM Void       IMPORT v;
FROM GrafBase   IMPORT Rectangle;

IMPORT MagicAES, MagicStrings;

IMPORT ConfVars, Varnames;

CONST name = 'catuser.inf';
      eg   = 'Echt gut';
      em   = 'Echt Mist';
      hs   = 'ST-GUIDE';

PROCEDURE ReadUserBlock();

VAR infFileName : ARRAY [0..140] OF CHAR;
    alt         : ARRAY [0..160] OF CHAR;
    deskSize    : Rectangle;

BEGIN
  (* Erst mal Default-Werte setzen! *)
  MagicAES.WindGet (0, MagicAES.WFWORKXYWH, deskSize);
(*     UserBlockType = RECORD
                       MakeAfterDecode, (* INFILE erstellen nach *)
                       MakeAtEnd,
                       Umbruch,
                       DeleteAfterDecode,
                       autosave,
                       DecodeAtStart,
                       DecodeAfterRun,
                       StartTermAtStart,
                       TermAsOverlay,
                       MakeBeforeTerminal,
                       UmlautWandler,
                       AutoUndo,
                       optimizeWindow,
                       ignoreRead : BOOLEAN;
                       editRight : INTEGER;      (* Rnder fr Editor *)
                       waitingTime : INTEGER;
                       ustr1, ustr2 : ARRAY[0..15] OF CHAR;
                       (*
                       INF  : InfArray;
                       *)
                       getPer,
                       getAllg,
                       getInf,
                       messToIn : BOOLEAN;
                       initialQuote,
                       security, groupChangeToIn : BOOLEAN;
                       infoline : ARRAY[0..79] OF CHAR;
                       buttonW :  Rectangle; (* Fensterpositionen *)
                       watchBox,
                       InfoInSlider : BOOLEAN;
                       sortGroups   : BOOLEAN;
                       RedirectArcer: BOOLEAN;
                       ShowCR       : BOOLEAN;
                       autoSplit    : BOOLEAN;
                       endlessLines: BOOLEAN;
                       tabSize      : INTEGER;
                       splitSize    : INTEGER;
                     END; *)

  (*
  UserBLK := UserBlockType{TRUE, FALSE, TRUE, FALSE, FALSE, FALSE, FALSE, FALSE,
                           FALSE, TRUE, FALSE, FALSE, FALSE, FALSE,
                           79, 100, eg+0C, em+0C, hs+0C, (*InfArray{FALSE BY 20}, *)
                           TRUE, TRUE, FALSE, TRUE, FALSE, TRUE,
                           TRUE, "U' am 'd, A T' in 'g"+0C+0C, "U' wrote in 'G, m", Rectangle {0,0,80,120},
                           FALSE, FALSE, TRUE, TRUE, TRUE, FALSE, TRUE, 4, 14336, FALSE, TRUE};
*)
  MagicStrings.Assign (DataPath,infFileName);
  MagicStrings.Append (name, infFileName);
  v.bool := ConfVars.ReadConfigFile (infFileName);

  WITH UserBLK DO
    ConfVars.GetConfDefBool (cMakeAfterDec, MakeAfterDecode, TRUE);
    ConfVars.GetConfDefBool (cMakeAtEnd, MakeAtEnd, FALSE);
    ConfVars.GetConfDefBool (cUmbruch, Umbruch, TRUE);
    ConfVars.GetConfDefBool (cDelAfterDecode, DeleteAfterDecode, FALSE);
    ConfVars.GetConfDefBool (cAutosave, autosave, FALSE);
    ConfVars.GetConfDefBool (cDecAtStart, DecodeAtStart, FALSE);
    ConfVars.GetConfDefBool (cDecAfterRun, DecodeAfterRun, FALSE);
    ConfVars.GetConfDefBool (cTermAtStart, StartTermAtStart, FALSE);
    ConfVars.GetConfDefBool (cMakeBeforeTerm, MakeBeforeTerminal, TRUE);
    ConfVars.GetConfDefBool (cTermOverlay, TermAsOverlay, FALSE);
    ConfVars.GetConfDefBool (cUmlaut, UmlautWandler, FALSE);
    ConfVars.GetConfDefBool (cAutoUndo, AutoUndo, TRUE);
    ConfVars.GetConfDefBool (cInfoReadonly, infoRO, FALSE);

    ConfVars.GetConfDefBool (cIgnoreRead, ignoreRead, FALSE);

    ConfVars.GetConfDefRect (cButton, buttonW, Rectangle{0, 0, 80, 120});

    ConfVars.GetConfDefInt (cMargin, editRight, 79);
    ConfVars.GetConfDefInt (cWaiting, waitingTime, 100);

    ConfVars.GetConfDefStr (cUser1, ustr1, eg);
    ConfVars.GetConfDefStr (cUser2, ustr2, em);
    ConfVars.GetConfDefStr (cHelpServer, helpServer, hs);

(*
    FOR i := iie TO MAX(infType) DO 
      ConfVars.GetConfDefBool (InfoFileTable[i], INF[i], FALSE);
    END;
*)
    
    ConfVars.GetConfDefBool (cPersToIn, getPer, TRUE);
    ConfVars.GetConfDefBool (cSendPE, getOwnPers, FALSE);
    ConfVars.GetConfDefBool (cAllgToIn, getAllg, TRUE);
    ConfVars.GetConfDefBool (cInfoToIn, getInf, TRUE);
    ConfVars.GetConfDefBool (cMessToIn, messToIn, TRUE);
    ConfVars.GetConfDefBool (cGroupsToIn, groupChangeToIn, TRUE);
    ConfVars.GetConfDefBool (cStatusToIn, statusToIn, TRUE);

    ConfVars.GetConfDefBool (cInitials, initialQuote, FALSE);
    ConfVars.GetConfDefBool (cSecurity, security, TRUE);

    ConfVars.GetConfDefStr (cInfoline1, infoline1, "U' schrieb am 'A' in der Msg 'M' (Gruppe 'G'):'");
    ConfVars.GetConfDefStr (cInfoline2, infoline2, "'In Msg 'M, U' wrote:'");

    ConfVars.GetConfDefBool (cWatchBox, watchBox, FALSE);

    ConfVars.GetConfDefBool (cSortGroups, sortGroups, TRUE);
    ConfVars.GetConfDefBool (cRedirect, RedirectArcer, TRUE);
    ConfVars.GetConfDefBool (cShowCr, ShowCR, TRUE);
    ConfVars.GetConfDefBool (cAutoSplit, autoSplit, FALSE);
    ConfVars.GetConfDefBool (cAbsatz, endlessLines, TRUE);

    ConfVars.GetConfDefBool (cIgnoreFiltered, ignoreFiltered, TRUE);
    
    ConfVars.GetConfDefInt  (cTabsize, tabSize, 4);
    IF tabSize <= 0 THEN tabSize := 4; END;
    ConfVars.GetConfDefLongInt  (cSplitSize, splitSize, 14336);
    IF splitSize < 0 THEN splitSize := 14336; END;

    ConfVars.GetConfDefBool (cMessDate, messDateToIn, TRUE);
  END; (* WITH *)
END ReadUserBlock;

BEGIN
  batchProcess := FALSE;
  (*
  InfoFileTable := infTableType {'IIE','IIB','IIA','IIG','IIH','IIM','IIL',
                                 'IIT','IIK','INA','INK','INL','ING','INP',
                                 'IGT','IGS','IGK','IGL','ISB','ISG'};
  *)
END UserInformation.
