DEFINITION MODULE Varnames;
(*$R-,S-,N+,M-*)

EXPORT   
        cShowLog, cAutoSplit, cAbsatz, cMakeAfterDec, cMakeAtEnd,
        cDelAfterDecode, cDecAtStart, cDecAfterRun, cTermAtStart, cViewWrap,
        cViewFastWrap, cMagicPCKeys,
        cTermOverlay, cMakeBeforeTerm, cSplitSize, cUmbruch, cAutosave, 
        cUmlaut, cAutoUndo, cIgnoreRead, cIgnoreFiltered, cInitials, cSecurity, 
        cRedirect, cShowCr, cSavePos, cRealTabs, cWaiting, cMargin, cTabsize, 
        cInfoline1, cInfoline2, cUser1, cUser2, cPersToIn, cSendPE, cAllgToIn, cInfoToIn, 
        cMessToIn, cGroupsToIn, cStatusToIn, cPrtHeader, cPrtPort, cPrtNlq, 
        cPrtStyle, cPrtFF, cPrtCfg, cPrtMargin, cPrtLines, 
        cMsgTextCol, cMsgBackCol, cMsgHoldCol, cMsgHoldEff, cGrinTextCol, 
        cGrinQuoteCol, cGrinQuoteEff, cGrinBackCol, cEditTextCol, cEditBackCol, 
        cListTextCol, cListQuoteCol, cListQuoteEff, cListBackCol, 
        cListOwnCol, cListOwnEff, cTreeUnreadCol, cTreeUnreadEff,
        cShiftFkey, cCtrlFkey, cReadMess, cWatchBox, cSortGroups, cSortNames, 
        cOverlayTerm, cPrivateLine, cGlobalLine, cHelpServer, cInfoReadonly,
        cMessDate, cParseEffects, cLastInfName, cNeoDeskFix, cNoInfoBackups,
        cClearBackground, cUseTmpPath, cFilter, cSetAppName, 
        cHiddenFeatures, cAdvanced,
        cExternHelp, cWaitAfterTerm, cIdealist, cIdealistParm, 
        cExternalPrint, cMintDomain, cWinAlerts, 
        (* IO-Filter *)
        cIoFilterProg, cIoFilterInCmd, cIoFilterOutCmd, cIoFilterMsg,
        cIoFilterInfile, cIoFilterOutfile, cIoFilterPast, cIoFilterActiv,
        cIoFilterName, cIoFilterStopAtErr,
        (* CATBUTTON.I  *) 
        cButton, cButtonOpen,
        (* CATEDIT.I    *)
        cEditWindow, cEditFont, cEditSize, cEditTabs, cEditTabSize, cEditWrap, 
        cEditMargin, cEditFile, cEditInfo, cEditZeile, cEditRow, cAutoIndent,
        cEditShowCr,
        cMsgWithoutHScroll, cMsgUseBEvent,
        (* GRIN.I       *)
        cMsgWindow, cMsgFont, cMsgSize, cMsgAltFont, cMsgAltSize, 
        cMsgGroup, cMsgMessage, cSuppressRef,
        cPersRestricted, cSpacePaging, cAutoNextGroup, cAutoNextPing, 
        cViewHeaderMode, cPostponeResubs,
        (* MSGLIST.I    *)
        cListFont, cListSize, cListWdw, cListGroup, cListStart, cListLeftOffset, 
        cListLineDist, cListSort, cListShrink, cListFilter, cListSearch, cListCase,
        cExtendedMode,
        (* MSGMANAGER.I *)
        cfgEdit, cfgOpen, cfgWindow, cfgFont, cfgFontSize, cfgLeftOffset, cfgLineDist,
        cfgMax, cMemLine, cMataGroup, cSendPsn, cAutoIndDflt,
        (* data.i *)
        cDangerousDupeMode, cUsenetChaining,
        (* parser.i *)
        cOwnName, cRedirectToLog, cFilteredRead, cRedrawCheck, cUseLongIDs, 
        cBufferAlert,
        (* treeList.i *)
        cTreeFont, cTreeSize, cTreeWdw, cTreeTextCol, cTreeBackCol, cTreeSubjectCol,
        cTreeUpLevels, cTreeMaxDepth,
        (* searchhelp.i *)
        cSearchStr, cSearchLogical, cSearchLocation, cSearchShow, cSearchChange,
        cSearchStatus, cSearchAsk, cSearchText, cSearchCasesensitive,
        cSearchSetBits, cSearchClearedBits, cSearchToSetBits, cSearchToClearBits,
        cNoGroupBorder,
        (* zsearchdial.i *)
        cMoreOptions, cFlagSetBits, cFlagClearBits, cFlagSelection,
        (* listHelp.i *)
        cSmallWriteList,
        (* gruppena.i *)
        cLokalSelectList, cSortSelectList,
        (* CatHelp *)
        cHyperText,
        (* DoITK *)
        cItkCmd, cItkCmdVersion, cItkCmdMax,
        (* CatReg *)
        cRegName, cRegStreet, cRegCity, cRegCountry, cRegEmail,
        (* WiederVorlage *)
        cLastResub,
        (* MTEdit2 *)
        cExtension, cExtTabsize, cExtHardTabs, 
        cExtWordWrap, cExtRightMargin, cExtAutoBackup;

CONST

        (* CAT.M *)
        
        cShowLog        = 'ShowLogAfterImport'; (* "decode" ist komisch *)
        cAutoSplit      = 'AutomaticSplit';
        cAbsatz         = 'SendParagraphs';
        cMakeAfterDec   = 'MakeInfileAfterImport';
        cMakeAtEnd      = 'MakeInfileAtEnd';
        cDelAfterDecode = 'DeleteAfterImport';
        cDecAtStart     = 'ImportAtStart';
        cDecAfterRun    = 'ImportAfterTermPrg';
        cTermAtStart    = 'StartTermAtStart';
        cTermOverlay    = 'TerminalAsOverlay';
        cMakeBeforeTerm = 'MakeInfileBeforeTerminal';
        cSplitSize      = 'SplitSize';
        
        cMagicPCKeys    = 'MagicPCKeyTranslation';
        cUmbruch        = 'WordWrap';
        cViewWrap       = 'ViewWrap';
        cViewFastWrap   = 'ViewFastWrap';
        cAutosave       = 'AutoSaveOptions';    (* !! Info-Text anders *)
        cUmlaut         = 'ConvertDiaresis';
        cAutoUndo       = 'AutoUndo';
        cIgnoreRead     = 'IgnoreRead';
        cIgnoreFiltered = 'IgnoreFiltered';
        cInitials       = 'InitialQuote';
        cSecurity       = 'SillyChecks'; (* :-) *)
        cRedirect       = 'RedirectPacker'; (* wer benutzt schon ARC *)
        cShowCr         = 'ShowLineEnds';
        cSavePos        = 'SaveAllPositions';
        cRealTabs       = 'HardTabs';
        cInfoReadonly   = 'InfofilesReadOnly';
        cMessDate       = 'MessageDateInInfile';
        cParseEffects   = 'DisplayEffects';
        cHiddenFeatures = 'HiddenFeatures';
        cAdvanced       = 'AdvancedFeatures';

        cWaiting        = 'WaitingTime';
        cMargin         = 'RightMargin';
        cTabsize        = 'TabSize';
        cInfoline1      = 'ReferenceLine1';
        cInfoline2      = 'ReferenceLine2';
        cUser1          = 'UserString1';
        cUser2          = 'UserString2';
        cHelpServer     = 'HelpServer';
        cExternHelp     = 'ST-GuideHelp';
        cWaitAfterTerm  = 'WaitAfterTerm';
        
        cPersToIn       = 'RequestPmails';
        cSendPE         = 'RequestBackOwnPmails';
        cAllgToIn       = 'RequestGrpMsgs';
        cInfoToIn       = 'RequestInfofiles';
        cMessToIn       = 'MessagesInInfile';
        cGroupsToIn     = 'GroupChangesInInfile';
        cStatusToIn     = 'StatusMessagesInInfile';
        
        cPrtHeader      = 'PrintHeaderType';
        cPrtPort        = 'PrintPort';
        cPrtNlq         = 'PrintNLQ';
        cPrtStyle       = 'PrintStyle';
        cPrtFF          = 'PrintFormFeed';
        cPrtCfg         = 'PrintCFGFile';
        cPrtMargin      = 'PrintLeftMargin';
        cPrtLines       = 'PrintEmptyLines';
        cIdealist       = 'ExternalPrintProg';
        cIdealistParm   = 'ExternalPrintParm';
        cExternalPrint  = 'ExternalPrint';
        cMintDomain     = 'MiNTDomain';
        cWinAlerts      = 'AlertsInWindow';
        
        cMsgHoldCol     = 'MsgSelectHoldCol';
        cMsgHoldEff     = 'MsgSelectHoldEff';
        cMsgTextCol     = 'MsgSelectTextCol';
        cMsgBackCol     = 'MsgSelectBackCol';
        cGrinTextCol    = 'MsgTextCol';
        cGrinQuoteCol   = 'MsgQuoteCol';
        cGrinQuoteEff   = 'MsgQuoteEffect';
        cGrinBackCol    = 'MsgBackCol';
        cEditTextCol    = 'EditTextCol';
        cEditBackCol    = 'EditBackCol';
        cListTextCol    = 'ListTextCol';
        cListQuoteCol   = 'ListNotReadCol';
        cListQuoteEff   = 'ListNotReadEffect';
        cListBackCol    = 'ListBackCol';
        cListOwnCol     = 'ListOwnMessCol';
        cListOwnEff     = 'ListOwnMessEffect';
        
        cShiftFkey      = 'ShiftF';
        cCtrlFkey       = 'ControlF';
        
        cReadMess       = 'ShowMessages';
        cWatchBox       = 'WatchBox';
        cSortGroups     = 'SortGroups';
        cSortNames      = 'SortNames';
        cOverlayTerm    = 'OverlayTerminal';
        
        cPrivateLine    = 'PrivateMsgListElems';
        cGlobalLine     = 'GrpMsgListElems';
        
        cLastInfName    = 'LastCatInf';
        cNeoDeskFix     = 'NeoDeskBugFix';
        cNoInfoBackups  = 'NoInfofileBackups';
        cClearBackground= 'ClearBackground';
        cUseTmpPath     = 'UseTmpPath';
        cFilter         = 'BlockFilter';
        cSetAppName     = 'ApplicationNameInWindow';

        cIoFilterProg   = 'IoFilterProgram';
        cIoFilterInCmd  = 'IoFilterInCmdline';
        cIoFilterOutCmd = 'IoFilterOutCmdline';
        cIoFilterMsg    = 'IoFilterBeforeMsg';
        cIoFilterInfile = 'IoFilterForInfile';
        cIoFilterOutfile= 'IoFilterForOutfile';
        cIoFilterPast   = 'IoFilterPastOutfile';
        cIoFilterActiv  = 'IoFilterActive';
        cIoFilterStopAtErr = 'IoFilterErrorBreak';
        cIoFilterName   = 'IoFilterName';
        
        (* CATBUTTON.I  *)
        cButton         = 'ButtonWindowPos';
        cButtonOpen     = 'ButtonWindowOpen';
        
        (* CATEDIT.I    *)
        cEditWindow     = 'EditWindowPos';
        cEditFont       = 'EditFont';
        cEditSize       = 'EditFontSize';
        cEditTabs       = 'EditTabs';
        cEditTabSize    = 'EditTabSize';
        cEditWrap       = 'EditWrap';
        cEditMargin     = 'EditMargin';
        cEditFile       = 'EditFile';
        cEditInfo       = 'EditInfo';
        cEditZeile      = 'EditLine';
        cEditRow        = 'EditRow';
        cAutoIndent     = 'EditAutoIndent';
        cEditShowCr     = 'EditShowLineEnds';
        
        (* GRIN.I       *)
        cMsgWithoutHScroll = 'MsgNoScrollbar';
        cMsgUseBEvent   = 'MsgMarkBackground';
        cMsgWindow      = 'MsgWindowPos';
        cMsgFont        = 'MsgFont';
        cMsgSize        = 'MsgFontSize';
        cMsgAltFont     = 'MsgAlternativeFont';
        cMsgAltSize     = 'MsgAlternativeSize';
        cMsgGroup       = 'MsgGroup';
        cMsgMessage     = 'MsgMessage';
        cSuppressRef    = 'SuppressRef';
        cPersRestricted = 'PrivateRestrictedMovement';
        cSpacePaging    = 'SpacePaging';
        cAutoNextGroup  = 'AutoNextGroup';
        cAutoNextPing   = 'AutoNextPing';
        cViewHeaderMode = 'ViewHeaderLevel';
        cPostponeResubs = 'PostponeResubmissions';
        
        (* MSGLIST.I    *)
        cListFont       = 'ListFont';
        cListSize       = 'ListFontSize';
        cListWdw        = 'ListWindowPos';
        cListGroup      = 'ListGroup';
        cListStart      = 'ListStart';
        cListLeftOffset = 'ListLeftOffset';
        cListLineDist   = 'ListLineDist';
        cListSort       = 'ListDefaultSort';
        cListShrink     = 'ListShowSmallList';
        cListFilter     = 'ListDontShowFiltered';
        cListSearch     = 'ListDefaultSelect';
        cListCase       = 'ListSortIgnoreCase';
        cExtendedMode   = 'ListExtendedCommentMode';
        
        (* MSGMANAGER.I *)
        cfgEdit         = 'MsgSelectEdit';
        cfgOpen         = 'MsgSelectOpen';
        cfgWindow       = 'MsgSelectWindowPos';
        cfgFont         = 'MsgSelectFont';
        cfgFontSize     = 'MsgSelectFontSize';
        cfgLeftOffset   = 'MsgSelectLeftOffset';
        cfgLineDist     = 'MsgSelectLineDist';
        cfgMax          = 'MsgSelectMaxNum';
        cMemLine        = 'MemoryLineInInfile';
        cMataGroup      = 'MausTauschGroupName';
        cSendPsn        = 'SendPSN';
        cAutoIndDflt    = 'EditAutoIndentDefault';
        
        (* data.i *)
        cDangerousDupeMode = 'DangerousDupeMode';
        cUsenetChaining    = 'UsenetChaining';
        
        (* parser.i *)
        cOwnName        = 'MausId';
        cRedirectToLog  = 'RedirectPackerToLog';
        cFilteredRead   = 'FilteredAreRead';
        cRedrawCheck    = 'CheckRedrawMsgCount';
        cUseLongIDs     = 'UseLongIDs';
        cBufferAlert    = 'EnableLowMemWarning';
        
        (* TREELIST.I   *)
        cTreeFont       = 'TreeFont';
        cTreeSize       = 'TreeFontSize';
        cTreeWdw        = 'TreeWindowPos';
        cTreeTextCol    = 'TreeTextCol';
        cTreeBackCol    = 'TreeBackCol';
        cTreeSubjectCol = 'TreeSubjChangeCol';
        cTreeUnreadCol  = 'TreeNotReadCol';
        cTreeUnreadEff  = 'TreeNotReadEffect';
        cTreeUpLevels   = 'TreeUpLevels';
        cTreeMaxDepth   = 'TreeMaxDepth';
        
        (* SearchHelp.i *)
        cSearchStr      = 'SearchStr';
        cSearchLogical  = 'SearchLogical';
        cSearchLocation = 'SearchLocation';
        cSearchShow     = 'SearchShow';
        cSearchChange   = 'SearchChange';
        cSearchStatus   = 'SearchStatus';
        cSearchAsk      = 'SearchAsk';
        cSearchText     = 'SearchText';
        cSearchCasesensitive = 'SearchCasesensitive';
        cSearchSetBits  = 'SearchSetBits';
        cSearchClearedBits = 'SearchClearedBits';
        cSearchToSetBits   = 'SearchToSetBits';
        cSearchToClearBits = 'SearchToClearBits';
        cNoGroupBorder     = 'SearchAllGroups';

        (* ZSearchDial.i *)
        cMoreOptions    = 'MoreSearchOptions';
        cFlagSetBits    = 'FlagSetValue';
        cFlagClearBits  = 'FlagClearValue';
        cFlagSelection  = 'FlagSelection';

        (* LISTHELP.I   *)
        cSmallWriteList = 'SmallWriteList';
        
        (* GruppenA.I *)
        cLokalSelectList= 'GroupSelectLocalList';
        cSortSelectList = 'GroupSelectSortType';
        
        (*  CatHelp.I *)
        cHyperText      = 'CatHelpText';

        (*  DoITK.I *)
        cItkCmd         = 'MTCmd';
        cItkCmdVersion  = 'MTCmdVersion';
        cItkCmdMax      = 'MTCmdMaxIdent';

        (*  CatReg.I *)
        cRegName        = 'RegName';
        cRegStreet      = 'RegStreet';
        cRegCity        = 'RegCity';
        cRegCountry     = 'RegCountry';
        cRegEmail       = 'RegEmail';

        (*  Wiedervo.I *)
        cLastResub      = 'LastResubmissionDate';

        (* MTEdit2 *)
        cExtension      = 'Extension';
        cExtTabsize     = 'ExtTabSize';
        cExtHardTabs    = 'ExtHardTabs';
        cExtWordWrap    = 'ExtWordWrap';
        cExtRightMargin = 'ExtRightMargin';
        cExtAutoBackup  = 'ExtAutoBackup';

END Varnames.
