(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtFiles      Grobes Filehandling, aber funktionstchtig.             *
 *              Setzt direkt auf dem GEMDOS auf.                        *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtFiles;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



IMPORT SYSTEM;

TYPE    FILE =  sINTEGER;        (* GEMDOS-Handle *)

PROCEDURE CreateFile (REF  name: ARRAY OF CHAR; VAR file: FILE);
(* Legt eine neue Datei an *)

PROCEDURE OpenFile (REF  name: ARRAY OF CHAR; VAR file: FILE);
(* ffnet eine vorhandene Datei *)

PROCEDURE CloseFile (VAR file: FILE);
(* Schliet eine Datei *)

PROCEDURE WriteFile (file: FILE; VAR num: lCARDINAL; buffer: SYSTEM.ADDRESS);
(* Schreibt num Zeichen aus buffer in file. num enthlt nach Aufruf die
 * Anzahl der tatschlich geschriebenen Zeichen
 *)

PROCEDURE ReadFile (file: FILE; VAR num: lCARDINAL; buffer: SYSTEM.ADDRESS);
(* Liest num Zeichen aus file in buffer. num enthlt nach Aufruf die Anzahl der
 * tatschlich gelesenen Zeichen
 *)

END mtFiles.

