DEFINITION MODULE mtXRsrc;

IMPORT SYSTEM;
IMPORT mtUtils;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET,
                        CastToChar, CastToByte, CastToByteset, CastToInt,
                        CastToCard, CastToBitset, CastToWord, CastToLInt,
                        CastToLCard, CastToLBitset, CastToLWord, CastToAddr,
                        TosVersion, Accessory, Basepage, SysHeader, TosDate;

(*$Z+*)
(*$[+ MM2: Returnwert in D0, Parameterbergabe ber Stack *)
TYPE
                  tRsBuffer = ARRAY[0..15] OF sINTEGER;   (* Fr die C-Lib *)

                  xrsrc_loadP = PROCEDURE ((* Name       *) SYSTEM.ADDRESS,
                                           VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_relocP= PROCEDURE (    (* Adr        *) SYSTEM.ADDRESS,
                                               (* length     *) lCARDINAL,
                                           VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_freeP = PROCEDURE (VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_gaddrP= PROCEDURE (    (* Type       *) sINTEGER,
                                               (* Index      *) sINTEGER,
                                           VAR (* Gaddr      *) SYSTEM.ADDRESS,
                                           VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_saddrP= PROCEDURE (    (* Type       *) sINTEGER,
                                               (* Index      *) sINTEGER,
                                           VAR (* Saddr      *) SYSTEM.ADDRESS,
                                           VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_obfixP= PROCEDURE (    (* Tree       *) SYSTEM.ADDRESS,
                                               (* Object     *) sINTEGER) : sINTEGER;
                  init_xrsrcP = PROCEDURE (    (* vdi_handle *) sINTEGER,
                                           VAR (* desk       *) mtUtils.tRect,
                                               (* wbox       *) sINTEGER,
                                               (* hbox       *) sINTEGER) : sINTEGER;
                  term_xrsrcP= PROCEDURE;

TYPE tRshCalls = RECORD
                  xrsrc_load  : xrsrc_loadP;
                  xrsrc_reloc : xrsrc_relocP;
                  xrsrc_free  : xrsrc_freeP;
                  xrsrc_gaddr : xrsrc_gaddrP;
                  xrsrc_saddr : xrsrc_saddrP;
                  xrsrc_obfix : xrsrc_obfixP;
                  init_xrsrc  : init_xrsrcP;
                  term_xrsrc : term_xrsrcP;

                END;
(*
TYPE tRshCalls = RECORD
                  (* $ K+ $R2+  Aufrufer rumt Stack, A2/D2 sichern (HM2) *)
                  xrsrc_load  : PROCEDURE ((* Name       *) SYSTEM.ADDRESS,
                                           VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_reloc : PROCEDURE (    (* Adr        *) SYSTEM.ADDRESS,
                                               (* length     *) lCARDINAL,
                                           VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_free  : PROCEDURE (VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_gaddr : PROCEDURE (    (* Type       *) sINTEGER,
                                               (* Index      *) sINTEGER,
                                           VAR (* Gaddr      *) SYSTEM.ADDRESS,
                                           VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_saddr : PROCEDURE (    (* Type       *) sINTEGER,
                                               (* Index      *) sINTEGER,
                                           VAR (* Saddr      *) SYSTEM.ADDRESS,
                                           VAR (* pglobal    *) tRsBuffer) : sINTEGER;
                  xrsrc_obfix : PROCEDURE (    (* Tree       *) SYSTEM.ADDRESS,
                                               (* Object     *) sINTEGER) : sINTEGER;
                  init_xrsrc  : PROCEDURE (    (* vdi_handle *) sINTEGER,
                                           VAR (* desk       *) mtUtils.tRect,
                                               (* wbox       *) sINTEGER,
                                               (* hbox       *) sINTEGER) : sINTEGER;
                  term_xrsrc : PROCEDURE;
                  (* K= R2=*)

                END;
*)
(*$Z=,[= MM2: Returnwert in D0, Parameterbergabe ber Stack *)

VAR RshCalls : POINTER TO tRshCalls;

PROCEDURE InitMtXrsrc ();
(* Setzt RshCalls richtig *)

(*$Z+*)
(*$[+ MM2: Returnwert in D0, Parameterbergabe ber Stack *)

PROCEDURE XrsrcLoad ( Name: SYSTEM.ADDRESS; VAR pglobal: tRsBuffer) : sINTEGER;
PROCEDURE XrsrcReloc (Adr: SYSTEM.ADDRESS; length: lCARDINAL; 
                      VAR pglobal: tRsBuffer) : sINTEGER;
PROCEDURE XrsrcFree (VAR pglobal: tRsBuffer) : sINTEGER;
PROCEDURE XrsrcGaddr ( Type: sINTEGER; Index: sINTEGER;
                       VAR Gaddr: SYSTEM.ADDRESS;
                       VAR pglobal: tRsBuffer) : sINTEGER;
PROCEDURE XrsrcSaddr ( Type: sINTEGER; Index: sINTEGER;
                       VAR Saddr: SYSTEM.ADDRESS;
                       VAR pglobal: tRsBuffer) : sINTEGER;
PROCEDURE XrsrcObfix ( Tree: SYSTEM.ADDRESS; Object: sINTEGER) : sINTEGER;
PROCEDURE InitXrsrc ( vdi_handle : sINTEGER; VAR desk: mtUtils.tRect;
                      wbox: sINTEGER; hbox: sINTEGER) : sINTEGER;
PROCEDURE TermXrsrc ();

END mtXRsrc.
