DEFINITION MODULE PutzRsc;

FROM SYSTEM IMPORT ADDRESS;

FROM GrafBase   IMPORT Rectangle;
     
FROM MagicAES   IMPORT
     OBJECT, BITBLK, ICONBLK, TEDINFO;

FROM Strings    IMPORT String;

FROM Lists      IMPORT List;

FROM PutzTypes   IMPORT delState, putzOptsRec;

(* GEM-Handling: consts and types *)
CONST   Root            = 0;
        MaxDepth        = 999;

TYPE    PtrObjTree      = POINTER TO ARRAY [0..MaxCard] OF OBJECT;
        MaxStr          = ARRAY [0..255] OF CHAR;
        PtrMaxStr       = POINTER TO MaxStr;
        PtrBitBlock     = POINTER TO BITBLK;
        PtrIconBlock    = POINTER TO ICONBLK;
        PtrTedInfo      = POINTER TO TEDINFO;
        TwoRects        = ARRAY[0..1] OF Rectangle;

VAR     selectBox,
        infoBox,
        info2Box,
        helpBox,
        pathBox,
        optBox,
        actBox,
        wdwIcon,
        menu           : PtrObjTree;

PROCEDURE InitResource (VAR resourceName : ARRAY OF CHAR) : BOOLEAN;
  
PROCEDURE ReplaceStr (VAR str : ARRAY OF CHAR; REF s1, s2 : ARRAY OF CHAR);

PROCEDURE LoadParameter(REF dataPath: ARRAY OF CHAR);

PROCEDURE SaveParameter(REF dataPath: ARRAY OF CHAR);

PROCEDURE doInfo();

PROCEDURE doOptBox (oneGroup : BOOLEAN; VAR putzOpts: putzOptsRec): BOOLEAN;

PROCEDURE doPathBox (VAR useTmp : BOOLEAN; VAR tmp : ARRAY OF CHAR):BOOLEAN;

PROCEDURE ClrRsrc();

PROCEDURE GetTreeAddr (tree: INTEGER): ADDRESS;

END PutzRsc.
