IMPLEMENTATION MODULE ARCAss;

FROM SYSTEM IMPORT ASSEMBLER, ADDRESS;

(*$L-,C-,R-,S-*)

VAR   
  saveProc:    ADDRESS;
  setAdr:      ADDRESS;
  newProc:     ADDRESS;
  saveUSP:     ADDRESS;
  savenstat2,
  savenstat5,
  saveout2,
  saveout5,
  savein2,
  savein5,
  savestat2,
  savestat5:  ADDRESS;
  myStack:     ARRAY [0..2047] OF CHAR;


PROCEDURE newnstat();
BEGIN
  ASSEMBLER
    ; Es liegt nie ein Zeichen an. 
    ; als Long wegen $%&@ HSMODEM1
    moveq   #0,d0
  END;
END newnstat;

VAR     outProc :   outProcType;

PROCEDURE newout();
 BEGIN
  ASSEMBLER
    movem.l d0-a6,-(sp)     ; Register sichern 
    move.l  outProc,d0      ; Adresse der Ausgabeprozedur nach A0
    beq.s   nix             ; ist nicht gesetzt
    move.l  d0,a0           ; 
    move.w  $42(sp),d0      ; Zeichen vom Stack holen 
    rol.w   #8,d0           ; fr MM2 umdrehen
    lea     myStack,a3      ; eigenen Stack einrichten 
    move.w  d0,(a3)+        ; Zeichen auf A3-Stack geben fr MM2
    jsr     (A0)            ; Ausgabeprozedur anspringen
nix:
    movem.l (sp)+,d0-a6     ; Register sichern 
    move.w  #1,d0           ; 'Kein Fehler' zurckgeben
  END;
 END newout;

(*
PROCEDURE newout();
BEGIN
  ASSEMBLER
    move.w  #1,d0
    rts
  END;
END newout;
*)

PROCEDURE newin();
BEGIN
  ASSEMBLER
    moveq   #0,d0
  END;
END newin;

PROCEDURE newstat();
BEGIN
  ASSEMBLER
    moveq   #-1,d0
  END;
END newstat;
            
PROCEDURE SetTrap();
BEGIN
  ASSEMBLER
PROC01:    
             clr.l     -(sp)            ; 
             move.w    #$20,-(sp)       ; Super
             trap      #1
             addq.l    #6,sp            ; Stack korrigieren
             move.l    d0,saveUSP       ; alten Stack sichern
             
             move.l    $4f2,a0          ; _sysbase
             move.l    8(a0),a0         ; os->osbeg
             move.w    2(a0),d0         ; osversion
             cmpi.w    #$100,d0         ; TOS 1.0
             beq.w     inst_trap        ; ja, BIOS-Trap installieren
             
             ; Installation in xcon-Vektoren, mu per Hand gemacht werden, da 
             ; die nicht auf Langwortgrenzen liegen :-(
             move.l    #$51E,a0         ; Basisadresse nach a0
             move.l    8(a0),savenstat2 ; xconstat (2)
             move.l    20(a0),savenstat5 ; xconstat (2)
             move.l    #$53E,a0         ; Basisadresse nach a0
             move.l    8(a0),savein2    ; xconin (2)
             move.l    20(a0),savein5   ; xconin (2)
             move.l    #$55E,a0         ; Basisadresse nach a0
             move.l    8(a0),savestat2  ; xcostat (2)
             move.l    20(a0),savestat5 ; xcostat (2)
             move.l    #$57E,a0         ; Basisadresse nach a0
             move.l    8(a0),saveout2   ; xconout (2)
             move.l    20(a0),saveout5  ; xconout (2)

             move.l    #$51E,a0         ; Basisadresse nach a0
             move.l    #newnstat,8(a0)  ; neue xconstat Routine
             move.l    #newnstat,20(a0) ; neue xconstat Routine
             move.l    #$53E,a0         ; Basisadresse nach a0
             move.l    #newin,8(a0)     ; neue xconin Routine
             move.l    #newin,20(a0)    ; neue xconin Routine
             move.l    #$55E,a0         ; Basisadresse nach a0
             move.l    #newstat,8(a0)   ; neue xcostat Routine
             move.l    #newstat,20(a0)  ; neue xcostat Routine
             move.l    #$57E,a0         ; Basisadresse nach a0
             move.l    #newout,8(a0)    ; neue xconout Routine
             move.l    #newout,20(a0)   ; neue xconout Routine

             ; so, das war's. Raus aus Super modus und zurck
             move.l    saveUSP,-(sp)    ; alten Stack zurck
             move.w    #$20,-(sp)       ; Super
             trap      #1               ; back to user mode
             addq.l    #6,sp            ; stack korrigieren
             
             rts

inst_trap:   
             move.l    saveUSP,-(sp)    ; alten Stack zurck
             move.w    #$20,-(sp)       ; Super
             trap      #1               ; back to user mode
             addq.l    #6,sp            ; stack korrigieren
             
             move.l    #-1,-(sp)        ;neuer Vektor
             move.w    #45,-(sp)        ;BIOS Vektor
             move.w    #5,-(sp)         ;Setexc
             trap      #13              ;BIOS
             addq.l    #8,sp
             move.l    d0,saveProc

             move.l    #TrapProc,-(sp)    ;neuer Vektor
             move.w    #45,-(sp)        ;BIOS Vektor
             move.w    #5,-(sp)         ;Setexc
             trap      #13              ;BIOS
             addq.l    #8,sp
             rts
  END
END SetTrap;

PROCEDURE RestoreTrap();
BEGIN
  ASSEMBLER
PROC02:      
             clr.l     -(sp)            ; 
             move.w    #$20,-(sp)       ; Super
             trap      #1
             addq.l    #6,sp            ; Stack korrigieren
             move.l    d0,saveUSP       ; alten Stack sichern
             
             move.l    $4f2,a0          ; _sysbase
             move.l    8(a0),a0         ; os->osbeg
             move.w    2(a0),d0         ; osversion
             cmpi.w    #$100,d0         ; TOS 1.0
             beq.s     inst_trap        ; ja, BIOS-Trap installieren

             ; Installation in xcon-Vektoren, mu per Hand gemacht werden, da 
             ; die nicht auf Langwortgrenzen liegen :-(
             move.l    #$51E,a0         ; Basisadresse nach a0
             move.l    savenstat2,8(a0) ; xconstat (2)
             move.l    savenstat5,20(a0) ; xconstat (2)
             move.l    #$53E,a0         ; Basisadresse nach a0
             move.l    savein2,8(a0)    ; xconin (2)
             move.l    savein5,20(a0)   ; xconin (2)
             move.l    #$55E,a0         ; Basisadresse nach a0
             move.l    savestat2,8(a0)  ; xcostat (2)
             move.l    savestat5,20(a0) ; xcostat (2)
             move.l    #$57E,a0         ; Basisadresse nach a0
             move.l    saveout2,8(a0)   ; xconout (2)
             move.l    saveout5,20(a0)  ; xconout (2)

             move.l    saveUSP,-(sp)    ; alten Stack zurck
             move.w    #$20,-(sp)       ; Super
             trap      #1               ; back to user mode
             addq.l    #6,sp            ; stack korrigieren
             
             rts

inst_trap:
             move.l    saveUSP,-(sp)    ; alten Stack zurck
             move.w    #$20,-(sp)       ; Super
             trap      #1               ; back to user mode
             addq.l    #6,sp            ; stack korrigieren
             
             move.l    saveProc,-(sp)   ;alter Vektor
             move.w    #45,-(sp)        ;BIOS Vektor
             move.w    #5,-(sp)         ;Setexc
             trap      #13              ;BIOS
             addq.l    #8,sp
             rts
  END
END RestoreTrap;

PROCEDURE TrapProc();
BEGIN
  ASSEMBLER
PROC03:
             btst      #5,(sp)
             beq.s     NoSuper

             cmpi.w    #11,6(sp)
             bhi.s     TTStack
             cmpi.w    #3,6(sp)
             bne.s     weiter
             bra.s     ciao
TTStack:     cmpi.w    #3,8(sp)
             bne.s     weiter
             bra.s     ciao
weiter:      move.l    saveProc,-(sp)
             rts

ciao:        
(*             break
             move.l    setAdr,a0
             move.b    10(sp),(a0)
             movem.l   d2-d7/a1-a6,-(sp)
             lea       myStack,a3
             move.l    newProc,a0
             jsr       (a0)
             movem.l   (sp)+,d2-d7/a1-a6 *)
             clr.l     d0
             rte

NoSuper:     move.l    a0,-(sp)
             move.l    usp,a0
             cmpi.w    #3,(a0)
             bne.s     weiter2
             bra.s     ciao2
weiter2:     movea.l   (sp)+,a0
             move.l    saveProc,-(sp)
             rts
ciao2:       
(*             break
             move.l    setAdr,a0
             move.b    10(sp),(a0)
             movem.l   d2-d7/a1-a6,-(sp)
             lea       myStack,a3
             move.l    newProc,a0
             jsr       (a0)
             movem.l   (sp)+,d2-d7/a1-a6
*)
             clr.l     d0
             movea.l   (sp)+,a0
             rte

  END
END TrapProc;

PROCEDURE SetCharAddress(adr : ADDRESS);
BEGIN
  ASSEMBLER
;(* Adresse, an der Speicheradresse fr das auszugebende Zeichen *)
PROC04:      move.l    -(a3),setAdr
             rts
  END
END SetCharAddress;

PROCEDURE SetNewProc(adr : ADDRESS);
BEGIN
  ASSEMBLER
;(* Adresse der auszufhrenden Proc *)
PROC05:      move.l    -(a3),newProc
             rts
  END
END SetNewProc;

PROCEDURE SetOutputProc (p: ADDRESS);
(* Setzt die Ausgabeprozedur fr die Ausgabeumlenkung
 *)
BEGIN
  ASSEMBLER
    MOVE.L  -(A3),outProc
  END;
END SetOutputProc;

PROCEDURE ClearOutputProc ();
(* Lscht eine ggf. gesetzte Ausgabeprozedur 
 *)
BEGIN
  outProc := outProcType(NIL);
END ClearOutputProc;

BEGIN
  outProc := outProcType(NIL);
END ARCAss.
