DEFINITION MODULE CatKeys;

CONST   (* Definition der Tasten-Codes: *)
        nul =           0C;     (* ASCII-Nul, kein Zeichen *)
        backspace =     10C;    (* rueckwaerts loeschen *)
        tab =           11C;    (* in 8er-Positionen einruecken *)
        delete =        177C;   (* Zeichen vorwaerts loeschen *)
        SHIFTdelete =   37C;    (* eigentlich Control-Delete!!! 
                                   Wort vorwaerts loeschen *)
        cursleft =      113C; (* Scan-Code, Zeichen nach links *)
        cursright =     115C; (* Scan-Code, Zeichen nach rechts *)
        ctrlleft =      163C; (* Scan-Code, Anfang der Zeile *)
        ctrlright =     164C; (* Scan-Code, Ende der Zeile *)
        cursup =        110C; (* Scan-Code, Zeile nach oben *)
        cursdown =      120C; (* Scan-Code, Zeile nach unten *)
        clear =         107C; (* Scan-Code, Zeile loeschen,
                                 mit SHIFT zum linken Zeilenr. loesch. *)
        SHIFTClear =    167C; (* Scan-Code, eigentlich Control-Delete!!!
                                 Block loeschen und puffern *)
        insert =        122C; (* Scan-Code, Ueberschreiben Ein/Aus,
                                 mit SHIFT Einruecken Ein/Aus *)
        help =          142C; (* Scan-Code, Hilfstafel rufen *)
        undo =          141C; (* Scan-Code, geloeschte Zeile wieder
                                 einfuegen *)
        F1 =             73C; (* Scan-Code *)
        F2 =             74C;
        F3 =             75C;
        F4 =             76C;
        F5 =             77C;
        F6 =            100C;
        F7 =            101C;
        F8 =            102C;
        F9 =            103C;
        F10 =           104C;
        SHIFTF1 =       124C;
        SHIFTF2 =       125C;
        SHIFTF3 =       126C;
        SHIFTF4 =       127C;
        SHIFTF5 =       130C;
        SHIFTF6 =       131C;
        SHIFTF7 =       132C;
        SHIFTF8 =       133C;
        SHIFTF9 =       134C;
        SHIFTF10 =      135C;

        hasinsert =     FALSE;
        hasdelete =     FALSE;
        
        insCh =         0C;
        delCh =         0C;
        ESC =           33C;
        LF =            12C;
        CR =            15C;
        BS =            10C;  
        TAB =           11C;  
        DEL =           177C;
        ctrlY =         31C;
        ctrlJ =         12C;
        ctrlK =         13C;
        ctrlSpace =     71C;    (* Scancode *)

END CatKeys.