DEFINITION MODULE Char;

(*
    Dieses Modul stellt zwei Tabellen zur Verfgung, die die Umwandlung von
    Kleinbuchstaben in Grobuchstaben und umgekehrt unter Bercksichtigung
    der nationalen Sonderzeichen ermglichen.
*)

TYPE
    tpTable = POINTER TO ARRAY CHAR OF CHAR;

PROCEDURE pUpper (): tpTable;
(*
    Liefert einen Zeiger auf eine Tabelle, die zu jedem Zeichen das zugehrige
    'groe Zeichen' liefert, d. h. bei kleinen Buchstaben den entsprechenden
    Grobuchstaben.
*)

PROCEDURE pLower (): tpTable;
(*
    Liefert einen Zeiger auf eine Tabelle, die zu jedem Zeichen das zugehrige
    'kleine Zeichen' liefert, d. h. bei groen Buchstaben den entsprechenden
    Kleinbuchstaben.
*)

END Char.
            
    
    
