DEFINITION MODULE EditUtil;

FROM SYSTEM IMPORT ADDRESS;

FROM EditTypes IMPORT EDITPTR, aLineDesc;

PROCEDURE EditSaveWdwPos (wdw : INTEGER);

PROCEDURE EditSavePos();
(* Sichert die Position und den Inhalt aller offenen Editorfenster
 * (nicht ReadOnly-Fenster) 
 *)

(* Einfge- und Lschoperationen *)

PROCEDURE IndentBlock (wdw : INTEGER);

        (* Hilfsfunktionen fr OpenEditor und EditMerge *)
        
PROCEDURE getFileParms (REF path, FileName : ARRAY OF CHAR;
                        new : BOOLEAN; alerts : BOOLEAN;
                        VAR fn : aLineDesc; VAR flen : LONGCARD;
                        VAR fHdl : INTEGER) : BOOLEAN;

PROCEDURE testMem (flen : LONGCARD; VAR memSize : LONGCARD;
                   VAR fastRead : BOOLEAN) : BOOLEAN;
 
PROCEDURE getReadBuff (memSize, flen : LONGCARD; VAR readBuf : ADDRESS) : BOOLEAN;

PROCEDURE EditPasteFile (wdw: INTEGER; isFilter: BOOLEAN; REF path, name: ARRAY OF CHAR);
(* Fgt einen Text mit Filename ein 
 *)

PROCEDURE SaveText (VAR ed : EDITPTR; saveas : BOOLEAN; takeName: BOOLEAN; REF fpath, fname : ARRAY OF CHAR) : BOOLEAN;

PROCEDURE PerformDragDrop (ed : EDITPTR; x, y: INTEGER; kstate, buts: BITSET);

PROCEDURE ClickIsInBlock (wdw : INTEGER; x, y: INTEGER) : BOOLEAN;
(* Gibt zurck, ob die Position x, y im Blockbereich liegt
 *)

PROCEDURE CheckWildAssign (VAR search, repl: ARRAY OF CHAR): BOOLEAN;
(* Prft die Konsistenz von Wildcards und ihren Gegenstcken im Such-
 * und Ersetzstring
 *)

PROCEDURE MarkMultiple (ed: EDITPTR);
(* Markiert multiple Blcke 
 *)

PROCEDURE WrapText (ed: EDITPTR; force: BOOLEAN): BOOLEAN;
(* Text umbrechen 
 * TRUE: Text wurde umgebrochen
 *)

END EditUtil.
