DEFINITION MODULE ExecV;
(*
 * v1.20 (c) 07.06.1991 Christian Sprenger - ExecMode = Exec
 * v1.10 (c) 23.05.1990 Christian Sprenger - tpStr, smtliche ExecModes
 * v1.00 (c) 07.02.1990 Christian Sprenger
 *
 * starten von Programmen nach ARGV-Verfahren
 *)

FROM SYSTEM IMPORT ADDRESS;

FROM MagicSys IMPORT sCARDINAL, sINTEGER;

TYPE
  tpStr = POINTER TO ARRAY [0..MAX(INTEGER)] OF CHAR;

VAR
  Environment: ADDRESS; (* Environment fr das gerufene Programm *)
  (* mu nach Pexec(Load)/Pexec(CreateBasePage) mit GEMDOS.Mfree(Environment)
     freigegeben werden.
     Im Falle von Pexec(LoadExec)/Pexec(ExecFree) erledigt das Pexec() selber
  *)

PROCEDURE Pexec(mode: sCARDINAL;
                VAR Path: ARRAY OF CHAR;
                VAR Cmdln: ARRAY OF CHAR;
                VAR Environment: ARRAY OF CHAR): sINTEGER;
(* startet ein Programm mit Pexec(), bergibt jedoch die Kommandozeile
   nach dem ARGV-Verfahren. Sie darf daher beliebig lang sein.
   Das erste Byte von cmdln wird nicht ausgewertet und ignoriert.
*)

END ExecV.
