DEFINITION MODULE grinTools;

(*==============================================================*
 * Modul:               Tools zum Anzeigemodul <grin>           *
 * Autor:               Johannes Gttker-Schnetmann             *
 * erstellt am:         10.04.1992                              *
 * letzte nderung am:  10.04.1992                              *
 * Version:             1.0                                     *
 * Interne Version:     V#0001                                  *
 *==============================================================*

 Behandelt die Aktionen, die im Anzeigefenster auftreten knnen:
 Weitergeben, Kopieren, Kommentieren, Beantworten, Gruppenkommentar

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  nderung (Arbeitsbericht)                            
 *----------------------------------------------------------------------------
 * 10.04.92 0001  JGS    Erste Version
 *----------------------------------------------------------------------------
 *)

FROM SYSTEM IMPORT ADDRESS;

(* Hier sollen demnchst auch die neuen Nachrichten erstellt werden, damit u.a. *)
(* BetreffHolen aus Cat komplett entfernt werden kann/ jetzt ist BetreffHolen   *)
(* hier original mit reinkopiert *)

(* Dann kann HandleComment/CopyResult und BetreffHolen aus Cat raus *)

TYPE ActionType = (comment, answer, copy, pass, otherGroup);

PROCEDURE LengthOf(VAR str : ARRAY OF CHAR):CARDINAL;
(* Liefert die Lnge eines Strings nach einer Umlautumwandlung *)

PROCEDURE CheckBetreff (VAR Betreff: ARRAY OF CHAR): BOOLEAN;
(* Prft nach, ob der Betreff alle gltigen Regeln einhlt *)

PROCEDURE BetreffHolen(grinWdw: INTEGER; VAR Betreff : ARRAY OF CHAR; REF optStr, WGruppe, preStr : ARRAY OF CHAR;
                       askGrin : BOOLEAN):BOOLEAN;
(* Fhrt den Dialog mit der Betreffzeile durch.
 * Fragt ggf. bei grin nach der aktuellen an!
 *)

PROCEDURE GetCommentLine(VAR str : ARRAY OF CHAR; copy : BOOLEAN):BOOLEAN;
(* Wird in MsgManager auch gebraucht *)

PROCEDURE Handle(grinWdw: INTEGER; what : ActionType);

PROCEDURE Init(wegen, system : ADDRESS);
(* Objektbaum der Betreffauswahlbox und Kommentarzeilenbox *)

END grinTools.
