DEFINITION MODULE QuickSort;

FROM SYSTEM IMPORT ADDRESS, LOC;

FROM Lists IMPORT List;

(*$H+*)
TYPE compProc = PROCEDURE (ADDRESS, ADDRESS) : BOOLEAN;
     (* Der Vergleichsprozedur werden die Adressen (!!)
      * der zu vergleichenden Elemente bergeben. 
      * Wenn man ein Array OF ADDRESS sortiert, dann mu 
      * man doppelt dereferenzieren!!
      *)
     
     breakProc = PROCEDURE (): BOOLEAN;
     (* Diese Prozedur wird whrend des Sortierens regelmig
      * aufgerufen. Wenn diese TRUE zurckliefert, dann wird
      * das Sortieren abgebrochen
      *)

PROCEDURE noBreak (): BOOLEAN;
(* Gibt immer FALSE zurck, kann als Breakprozedur verwendet werden
 *)

PROCEDURE sortIt (low, high : LONGINT; VAR ptrelem : LONGARRAY OF LOC;
                  comp : compProc; entrySize : LONGINT;
                  break: breakProc): BOOLEAN;
(* Generelle Sort-Prozedur. 
 * Es wird ein Array of irgendwas sortiert, die Eintrge sind
 * alle entrySize Bytes gro. Fr die compProc werden die Adressen
 * selber berechnet.  
 *)

PROCEDURE ListSort (list: List; comp : compProc; break: breakProc): BOOLEAN;
(* Sortiert eine Liste mittels Zip-Sort (c) by Gerd Castan
 *)

END QuickSort.
