DEFINITION MODULE VDIStandards;

FROM SYSTEM     IMPORT ADDRESS, WORD, LOC;
FROM MagicVDI   IMPORT tPxyArray;

(*
TYPE drawProc    = PROCEDURE(INTEGER,INTEGER,INTEGER,INTEGER); (* x,y,w,h *)
     rProc       = PROCEDURE();
     wProc       = PROCEDURE(CARDINAL);
     fiveVarProc = PROCEDURE(CARDINAL, INTEGER,INTEGER,INTEGER,INTEGER);
*)
TYPE
     iProc       = PROCEDURE(INTEGER, INTEGER,INTEGER);

PROCEDURE InitVDIStandards():BOOLEAN;

PROCEDURE SelectFont (handle, wdw : INTEGER; onlyMono : BOOLEAN;
                      VAR font, size : INTEGER; setFont : iProc);

(* Ein bichen VDI-Erweiterung *)
PROCEDURE Text (isFSM : BOOLEAN; hdl, x, y: INTEGER; REF string: ARRAY OF CHAR);
          (* v_gtext *)

PROCEDURE InqTextextend (isFSM : BOOLEAN; hdl : INTEGER; REF string: ARRAY OF CHAR;
                         VAR extent: ARRAY OF LOC);
          (* vqt_extent *)

PROCEDURE GetSpec  (tree : ADDRESS; Item : INTEGER):ADDRESS;
PROCEDURE GetState (tree : ADDRESS; Item : INTEGER):BITSET;
PROCEDURE GetFlags (tree : ADDRESS; Item : INTEGER):BITSET;

PROCEDURE SetSpec  (tree : ADDRESS; Item : INTEGER; newSpec  : ADDRESS);
PROCEDURE SetState (tree : ADDRESS; Item : INTEGER; newState : BITSET);
PROCEDURE SetFlags (tree : ADDRESS; Item : INTEGER; newFlags : BITSET);

(* demnchst die INTEGER-Werte auf BITSETs umstellen *)

PROCEDURE CheckItem (tree : ADDRESS; item : INTEGER; enable : BOOLEAN);

PROCEDURE StatusEnable(yep : BOOLEAN);

PROCEDURE StatusCheck(b : BITSET);
PROCEDURE enableMenuItems(wdw : INTEGER);
PROCEDURE enableNewTop (wdw : INTEGER);

PROCEDURE enableOrDisableMenu (disable : BOOLEAN);
(* Enablet oder disablet alle Menueintrge *)

END VDIStandards.
