DEFINITION MODULE ZSearchDial;

IMPORT SearchHelp;

CONST FASTAHEAD = 0; FASTBACK = 1;

PROCEDURE DoSearchDial(forList: BOOLEAN):INTEGER;
(* Ruft die Suchbox auf; Rckgabe < 0 -> User hat Abbruch gedrckt *)
(* sonst noch mglich: FASTAHEAD, FASTBACK *)

PROCEDURE SearchDial(VAR suchVar : SearchHelp.SearchRecordType;
                     forList : BOOLEAN):INTEGER;

(* Die Vars sind gleichzeitig Eingabeparameter, damit werden die einzelnen
   Punkte gefllt, mu dem alten Aussehen entsprechen *)
(* wo1..wo4 und verkn1..verkn3 werden gem SearchHelp belegt!  *)
(* Rckgabewert gibt an, wie gestartet werden soll:             *)
(* FASTAHEAD = Schnellstart vorwrts    *)
(* FASTBACK  = Schnellstart rckwrts   *)
(* sonstige positive Werte: kein Start  *)
(* Rckgabe < 0 -> Abbruch              *)

PROCEDURE InitMenuStr():BOOLEAN;

TYPE DialAction = (ChangeMsg, ChangeTree, ChangeTreeDown, ChangeSelected);
TYPE DialActionSet = SET OF DialAction;

PROCEDURE FlagDial(possible : DialActionSet; 
                   VAR setBits, clearBits : BITSET;
                   VAR whatAction : DialAction):BOOLEAN;
(* Fr die Flagaktionen. Gibt zurck, ob der User ok angewhlt hat und den Status   *)
(* der Bits sowie die ber die Radiobuttons gewhlte Aktion                         *)

END ZSearchDial.
