; MT_BATCH.BAT
; Batch zum automatischen Einloggen in MAUS-Boxen mit Maustausch
; Das Passwort mu auf Shift-F1 liegen. Weitere Variablen (Mausname, Pfade)
; in diesem Script ab ca. Zeile 16 anpassen!
;
;                Fehlermeldungen in Dialog Modemkommandos  eintragen!
;                #1 No Carrier
;                #2 Busy
;                #3 Delayed (Standard: No Dialtone)
;                #4 No Answer (Standard: Error; auch bei Abbruch von Dial)
;
; Entstanden aus dem gleichnamigen Rufus-Batch von Mathias Weber @ S3
; ----------------------------------------------------------------------
; Konfiguration
; ----------------------------------------------------------------------
new
; alle Variablen lschen
;
; ab hier die passenden Pfade einsetzen!
$infile := d:\upload\infile.zip                
rem Dateiname des Infiles
$outfile := d:\download\outfile.zip
rem Dateiname des Outfiles, derzeit nicht genutzt
rem wird vom ZMODEM in den in Starcall eigestellten Pfad geschrieben
$modres := "atz"
rem Modem-Reset
$anwahl := 09232-91031
rem Anwahlstring 
$mausname := WUN
rem fr log-Datei
$loginname := MausTauschEkkehard Flessa
rem Benutzernamen anpassen, MausTausch stehenlassen!
rem das mu so hintereinander stehen, weil wait auf den Benutzernamen
rem nicht klappt (kommt wohl zu schnell)
$conlog := Connect to MAUS Wunsiedel
rem Log-Eintrag bei Connect; an angewhlte Maus anpassen
anwmax := 60
rem Maximale Zahl der Anwahlversuche
anwver := 1
rem Zhler init
leave 60
rem wartezeit bei "wait" 60 Sekunden
;-----------------------------------------------------------------------
;Startbildschirm anzeigen
;-----------------------------------------------------------------------
echo "@27E"
echo "@27E"
echo
echo "            Batchprogramm fr automatischen MausTausch mit Starcall           "
echo "                                 Version 0.52                                "
echo "              (C) Ekkehard Flessa AT WUN - Abbruch mit [Control]              "
echo
echo
echo
;-----------------------------------------------------------------------
;auf altes Outfile testen
;-----------------------------------------------------------------------
if exist $outfile
alert "[1][Es ist noch ein altes OUTFILE vorhanden][Abbruch]!"
log $mausname ^ Batchende wg. altem Outfile
end
; Batch abbrechen
endif
; ----------------------------------------------------------------------
; MAUS anwhlen
; ----------------------------------------------------------------------
:10
echo "@27H"
;Cursor in obere linke Ecke
putline
putline
putline
putline
putline
putline
putstring "                        Anwahlversuch Nr. "
putint anwver
echo "  "
echo "                     MAUS Wunsiedel wird angewhlt ...                     "
echo
putstring "--- Modem: ----------------------------------------------------"
echo "-----------------"
echo 
print $modres
wait "OK"

:11
D := dial $anwahl
putline
putline
putline
putstring "Rckmeldung von DIAL: "
putint D
putstring "  "
putline
if D=1 then goto 20 
; CONNECT erfolgt :-)
;
;Workaround: Werte fr Vergleich quadrieren
DUMM := D * D

if DUMM = 1 
goto 12 
; No Carrier, z.B. Maus abgestrzt oder Anwahl unterbrochen
endif

if DUMM = 4
goto 13 
; leider belegt :-(
endif

if DUMM = 9 
goto 14 
; auch bei delayed Fehlermeldung ausgeben und weitermachen
endif

if DUMM = 16 
goto 15 
; no Answer, Nach Abheben keine Antwort vom Fernmodem 
endif

echo "unbekannte Modemrckmeldung:"
putstring "Status: "
log $mausname ^ : unbekannte Modemrckmeldung
putint D
end

:12
;Fehlerbehandlung "no Carrier" 
anwver := anwver+1
if anwver>anwmax then goto 16
echo 
echo "MAUS hebt nicht ab oder Leitungsstrung - bitte warten ..."
echo 
log $mausname ^: No Carrier
leave 30
wait "ring"
leave 60
if (D > 0) then pause 120
; 2 Minuten warten, falls es gelutet hat
goto 10

:13
;Fehlerbehandlung "busy"
anwver := anwver+1
if anwver>anwmax then goto 16
echo "MAUS ist zur Zeit belegt - bitte warten ...               "
echo 
log $mausname ^ : Besetzt
leave 26
D := wait "ring"
leave 60
if (D > 0) then pause 120
; 2 Minuten warten, falls es gelutet hat
goto 10

:14
;Fehlerbehandlung "delayed"
;anwver := anwver+1
;if anwver>anwmax then goto 16
echo "Modem ist noch nicht soweit - bitte warten ...            "
echo 
log "delayed"
leave 15
D := wait "ring"
leave 60
if (D > 0) then pause 120
; 2 Minuten warten, falls es gelutet hat
goto 10

:15
;Fehlerbehandlung "No Answer"
;kommt auch, wenn man den DIAL-Dialog per CONTROL unterbrochen hat
anwver := anwver+1
if anwver>anwmax then goto 16
echo "Verbindung hat nicht geklappt - bitte warten ..."
echo 
log $mausname ^: No Answer
leave 20
D := wait "ring"
leave 60
if (D > 0) then pause 120
; 2 Minuten warten, falls es gelutet hat
goto 10


:16
;-----------------------------------------------------------------------
;zu oft Besetzt
;-----------------------------------------------------------------------
echo "Maximale Anzahl der Whlversuche berschritten"
log "Batch abgebrochen wg. berschreitung Maximalanzahl Whlversuche"
end
:20
;-----------------------------------------------------------------------
;Einloggen und Tauschen
;-----------------------------------------------------------------------
log $conlog
echo 
bell 0
echo "Batchprogramm fr automatischen MausTausch - Abbruch mit ESC"
echo "------------------------------------------------------------"
putstring "Connect nach "
putint anwver
echo " Anwahlversuch(en)"
echo
echo


; ab hier geht es zur Sache :-)
; der Batch ab hier liee sich auch standalone z.B. als Automatik-Batch
; bei der Telefonnummer angeben. Die verwendeten Variablen $loginname, $F11
; (Funktionstaste) und $infile mssen natrlich auch definiert sein.

WAIT (J/N) 

PRINT $loginname

WAIT Password
PRINT $F11
leave 10
WAIT Protokoll

WRITE Z

WAIT start
pause 1

UPLOAD $infile

; leave 480
; WAIT start
; DOWNLOAD $outfile
END
