(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtAESMenus   Manipulation der AES-Menzeile. Initialisiert die Men- *
 *              zeile, und bringt sie auf den Schrim. Installiert eine  *
 *              TermProc in mtAppl, so da man sich um das Zurcksetzen *
 *              der Menzeile nicht kmmern mu.                        *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtAESMenus;

IMPORT SYSTEM;

PROCEDURE InitMenuline (menu: SYSTEM.ADDRESS): BOOLEAN;
(* Initialisiert eine Menuzeile. Dabei werden die '----' Eintrge wie bei
 * Flydial-Programmen mit einer Linie ersetzt. Achtung! Dies gilt vorlufig
 * nur fr Megamax-Modula-2 Programme! Liefert FALSE wenn fehlgeschlagen!
 *)

PROCEDURE DrawMenuline (menu: SYSTEM.ADDRESS);
(* Bringt eine Menzeile auf den Schirm. Dabei wird eine TermProc in mtAppl
 * installiert, so da man sich bei Programmende nicht um das Zurcksetzen
 * der Menuzeile kmmern mu.
 *)

PROCEDURE ResetMenuline;
(* Setzt die Menzeile zurck. *)

END mtAESMenus.
