(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * mtMenubase   Basis fr die Module mtMenus und mtPopups.              *
 *                                                                      *
 * WICHTIG: Bei der Verwendung dieses Moduls sehr vorsichtig sein, da   * 
 *          es auf Besonderheiten von mtMenus und mtPopups eingeht!!!   *
 *----------------------------------------------------------------------*)

DEFINITION MODULE mtMenubase;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



IMPORT  MagicAES;
FROM mtUtils IMPORT tRect, tObjcTree;

PROCEDURE SameLength (menu: tObjcTree; num, max: sINTEGER);
(* Bringt alle Meneintrage auf gleiche Lnge *)

PROCEDURE DoEvent (VAR x, y: sINTEGER;
                   VAR button: sBITSET;
                   VAR scan: sINTEGER): sBITSET;
(* Event-Routine fr mtMenus und mtPopups *)

PROCEDURE ScreenDim (VAR mw, mh: sINTEGER);
(* Aktualisiert die Bildschirmgre *)

PROCEDURE DrawBar (t: tObjcTree; object: sINTEGER);
(* Zeichnet einen Meneintrag selektiert bzw. unselektiert *)

PROCEDURE MenuKeyboard (t: tObjcTree; scan, minobj, oldob: sINTEGER;
                        VAR ob: sINTEGER): BOOLEAN;
(* Berechnet neues Objekt anhand der Tastatureingaben *)

PROCEDURE PlaceOnScreen (t: tObjcTree);
(* Plaziert einen Menbaum auf dem Schirm. Dabei werden Rnder etc. beachtet *)

PROCEDURE InitMtMenubase;
(* Initialisiert mtMenubase. Wird normalerweise im Modulkrper
 * aufgerufen, und braucht nicht weiter beachtet zu werden.
 *)

END mtMenubase.
