(*----------------------------------------------------------------------*
 *                                                                      *
 *         MAGIC   Modula's  All purpose  GEM  Interface  Cadre         *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus in schrift-  *
 * licher Form, insbesondere in Zeitschriften, sowie die Verbreitung    *
 * ber Public-Domain-Hndler bedarf der ausdrcklichen schriftlichen   *
 * Genehmigung des Autors!                                              *
 *                                                                      *
 * Der Autor gibt hiermit die ausdrckliche Erlaubnis, das Modul jeder- *
 * zeit auch im Quelltext weiterzugegeben, sofern dessen Text und ins-  *
 * besondere dieser Urheberrechts-Vermerk nicht verndert wird, und     *
 * durch die Weitergabe kein finanzieller Nutzen entsteht. Der Autor    *
 * behlt sich das Recht vor, diese Erlaubnis jederzeit u. ohne Angaben *
 * von Grnden zu widerrufen.                                           *
 *----------------------------------------------------------------------*)
 
(*----------------------------------------------------------------------*
 * RTD  (R)un-(T)ime-(D)ebugging. Die Proz. geben ber das BIOS aus     *
 *----------------------------------------------------------------------*)

DEFINITION MODULE RTD;

FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET;

 



TYPE DEVICE = (printer, rs232, console);

PROCEDURE Into (REF  procedure: ARRAY OF CHAR);
(* Gibt String "I: procedure" aus, zhlt Verschachtelung mit *)

PROCEDURE Leaving (REF  procedure: ARRAY OF CHAR);
(* Gibt String "L: procedure" aus, zhlt Verschachtelung mit *)

PROCEDURE Message (REF  string: ARRAY OF CHAR);
(* Gibt String aus *)

PROCEDURE Write (REF  msg, string: ARRAY OF CHAR);
(* Schreibt msg, gefolgt von string *)

PROCEDURE ShowVar (REF  name: ARRAY OF CHAR; VAR value: ARRAY OF LOC);
(* Zeigt den Wert der Variablen name in DEC, HEZ und BIN an *)

PROCEDURE SetDevice (dev: DEVICE);
(* Schaltet das Ausgabegert (Drucker, Seriell oder Bildschirm um *)

PROCEDURE WaitKey;
(* Wartet auf einen Tastendruck *)

END RTD.

