(*----------------------------------------------------------------------*
 *                                                                      *
 *  MAGICTOOLS   Modula's  All purpose  GEM  Interface  Cadre  Toolbox  *
 *                                                                 *
 *----------------------------------------------------------------------*
 * Version 3.30  02.02.1992     (C)90/91/92 by Peter Hellinger Software *
 *----------------------------------------------------------------------*
 *            Dieses Modul ist urheberrechtlich geschtzt.              *
 *                                                                      *
 * Die Verffentlichung des Quelltextes oder Teilen daraus, sowie die   *
 * Verbreitung des bersetzten, nicht gelinkten Codes in schriftlicher, *
 * oder maschinenlesbarer Form, insbesondere in Zeitschriften, Mail-    *
 * boxen oder anderen Medien bedarf der ausdrcklichen schriftlichen    *
 * Einverstndnisserklrung des Autors.                                 *
 *                                                                      *
 * Die Verbreitung des Moduls als Teil eines gelinkten Programms ist    *
 * fr Lizenznehmer ausdrcklich erlaubt!  Der Autor behlt sich das    *
 * Recht vor, diese Erlaubnis jederzeit und ohne Angaben von Grnden zu *
 * widerrufen.                                                          *
 *----------------------------------------------------------------------*)
 
IMPLEMENTATION MODULE mtMenubase;



(* IMPLEMENTATION FR  >>> Megamax-Modula-2 <<< *)
(*                                              *)
(*$R-   Range-Checks                            *)
(*$S-   Stack-Check                             *)
(*                                              *)
(*----------------------------------------------*)








FROM Storage IMPORT ALLOCATE, DEALLOCATE;




FROM MagicSys   IMPORT  Nil, Null, Bit0, Bit1, Bit2, Bit3, Bit4, Bit5, Bit6,
                        Bit7, Bit8, Bit9, Bit10, Bit11, Bit12, Bit13, Bit14,
                        Bit15, LOC, Byte, ByteSet, sWORD, sINTEGER, sCARDINAL,
                        sBITSET, lINTEGER, lCARDINAL, lWORD, lBITSET,
                        CastToChar, CastToByte, CastToByteset, CastToInt,
                        CastToCard, CastToBitset, CastToWord, CastToLInt,
                        CastToLCard, CastToLBitset, CastToLWord, CastToAddr,
                        TosVersion, Accessory, Basepage, SysHeader, TosDate;

 




FROM SYSTEM     IMPORT  ADDRESS, ADR, TSIZE;
FROM MagicAES   IMPORT  GBOX, GTEXT, GBOXTEXT, GIBOX, GSTRING, GTITLE,
                        OUTLINED, SHADOWED, SELECTABLE,
                        Exit, DISABLED, OBJECT, ObjcDraw, ObjcFind, TEDINFO,
                        BEGMCTRL, ENDMCTRL, WindUpdate, WFFULLXYWH, WindGet,
                        FormButton, GrafHandle, MUKEYBD, MUBUTTON, MUM1, 
                        MUM2, MUMESAG, MUTIMER, EvntMulti, AESIntIn, AESIntOut,
                        AESCall;
FROM mtAppl     IMPORT  PrivateWS, MouseOn, MouseOff, MouseArrow, MouseHand,
                        CharWidth, CharHeight, BoxWidth, BoxHeight, DeskX,
                        DeskY, MaxWidth, MaxHeight;
FROM mtArea     IMPORT  AREA, NewAREA, DisposeAREA, FreeArea, SaveArea,
                        CopyArea, RestoreArea, MoveArea;
FROM MagicStrings  IMPORT  Assign, Append, Length;
FROM mtUtils       IMPORT  tRect, tObjcTree, ObjcFrame;
IMPORT  MagicAES, MagicVDI;

TYPE    tString =       ARRAY [0..40] OF CHAR;

VAR     rekExit:        BOOLEAN;
        screen:         tRect;

PROCEDURE SameLength (menu: tObjcTree; num, max: sINTEGER);
VAR i: sINTEGER;
BEGIN
 FOR i:= 0 TO num - 1 DO  menu^[i].obWidth:= max;  END;
END SameLength;

PROCEDURE DoEvent (VAR x, y: sINTEGER;
                   VAR button: sBITSET;
                   VAR scan: sINTEGER): sBITSET;
VAR event: sBITSET;
    i:     sINTEGER;
    split: RECORD
            CASE: BOOLEAN OF
             TRUE: wert: sINTEGER;|
             FALSE: hi: CHAR;
                    lo: CHAR;|
            END;
           END;
BEGIN
 (* Array's laden *)
 event:= {MUKEYBD, MUTIMER, MUBUTTON};
 AESIntIn[ 0]:= CastToInt (event);
 AESIntIn[ 1]:= 1;
 AESIntIn[ 2]:= 1;
 AESIntIn[ 3]:= 1;
 AESIntIn[14]:= 0;
 AESIntIn[15]:= 0;
 i:= AESCall(25, 16, 7, 1, 0);
 event:= CastToBitset (i);
 x:= AESIntOut[1];
 y:= AESIntOut[2];
 button:= CastToBitset (AESIntOut[3]);
 (* kbshift:= CastToBitset (AESIntOut[4]); *)
 split.wert:= AESIntOut[5];
 scan:= CastToInt (split.hi);
 (* ascii:= split.lo; *)
 RETURN event;
END DoEvent;

PROCEDURE ScreenDim (VAR mw, mh: sINTEGER);
VAR i: sINTEGER;
BEGIN
 mw:= screen.x + screen.w - 1;
 mh:= screen.y + screen.h - 1;
END ScreenDim;

PROCEDURE DrawBar (t: tObjcTree; o: sINTEGER);
BEGIN
 IF (o > 0) THEN
  IF NOT (DISABLED IN t^[o].obState) THEN
   MagicVDI.VDIPtsIn[0]:= t^[0].obX + t^[o].obX;
   MagicVDI.VDIPtsIn[1]:= t^[0].obY + t^[o].obY;
   MagicVDI.VDIPtsIn[2]:= MagicVDI.VDIPtsIn[0] + t^[o].obWidth - 1;
   MagicVDI.VDIPtsIn[3]:= MagicVDI.VDIPtsIn[1] + t^[o].obHeight - 1;
   MagicVDI.VDICall(11, 2, 0, 1, PrivateWS);
  END;
 END;
END DrawBar;

PROCEDURE MenuKeyboard (t: tObjcTree; scan, minobj, oldob: sINTEGER;
                        VAR ob: sINTEGER): BOOLEAN;
VAR o: sINTEGER;
BEGIN
 CASE scan OF
  114,
   28: RETURN TRUE;|
   72: o:= ob;
       IF o <= minobj THEN
         o := t^[0].obTail+1;
       END;
       REPEAT
         DEC (o);
       UNTIL (o < minobj) OR (~(DISABLED IN t^[o].obState) & (SELECTABLE IN t^[o].obFlags));
       IF o < minobj THEN  
         o := t^[0].obTail+1;
         REPEAT
           DEC (o);
         UNTIL (o < minobj) OR (~(DISABLED IN t^[o].obState) & (SELECTABLE IN t^[o].obFlags));
         IF o < minobj
         THEN
           o := t^[0].obTail;
         END;
       END;
       ob := o;|
   80: o:= ob;
       IF (o >= t^[0].obTail) THEN o := minobj-1; END;
       REPEAT
         INC (o);
       UNTIL (o > t^[0].obTail) OR (~(DISABLED IN t^[o].obState) & (SELECTABLE IN t^[o].obFlags));
       IF o > t^[0].obTail
       THEN
         o := minobj-1;
         REPEAT
           INC (o);
         UNTIL (o > t^[0].obTail) OR (~(DISABLED IN t^[o].obState) & (SELECTABLE IN t^[o].obFlags));
         IF o > t^[0].obTail
         THEN
           o := minobj;
         END;
       END; 
       ob := o;|
   97: ob:= -1;  RETURN TRUE;|
  ELSE ;
 END;
 RETURN FALSE;
END MenuKeyboard;

PROCEDURE PlaceOnScreen (t: tObjcTree);
VAR j: sINTEGER;
BEGIN
 WITH t^[0] DO
  j:= ObjcFrame (t, 0);  IF j < 0 THEN j:= ABS (j) ELSE j:= 0;  END;
  IF MagicAES.SHADOWED IN t^[0].obState THEN  j:= 3 * j;  END;
  IF (obX + obWidth + j) > screen.w THEN  obX:= screen.w - obWidth - j;  END;
  IF (obY + obHeight + j) > screen.h THEN  obY:= screen.h - obHeight - j;  END;
  IF obX - j < screen.x THEN  obX:= screen.x + j;  END;
  IF obY - j < screen.y THEN  obY:= screen.y + j;  END;
 END;
END PlaceOnScreen;

PROCEDURE InitMtMenubase;
BEGIN
 screen.x:= DeskX;  screen.y:= DeskY;
 screen.w:= MaxWidth;  screen.h:= MaxHeight;
END InitMtMenubase;

BEGIN
 InitMtMenubase;
END mtMenubase.
