                            CatPutz - Das Putzprogramm


Vorwort
=======

Diese Anleitung ist aus der Hypertext-Anleitung und -Hilfe zu CatPutz 3.0
entstanden. Daher knnen an einigen Stellen Verweise auftreten, die hier
so direkt nicht ersichtlich sind. Besser ist es, wenn Sie sich den 
ST-Guide besorgen und installieren und die Hypertext-Hilfe benutzen.


CatPutz - Was is'n das?
=======================

Mit CatPutz ist es mglich, Nachrichten aus einer Datenbank von CAT
zu lschen. CAT selbst hatte bis zur Version 1.21 immer nur sehr 
eingeschrnkte Lschmglichkeiten, und ab Version 2.0 kann CAT selbst gar 
keine Nachrichten mehr lschen. Der Vorteil dieser Trennung liegt ganz 
einfach darin, da CAT nicht noch grsser wird, als es jetzt schon ist 
und auf diesem Wege die Lschaktion mit CatPutz wesentlich komfortabler 
gestaltet werden kann. Dabei untersttzt CatPutz auch einige Flags aus CAT, 
die Sie fr selektive Lschaktionen verwenden knnen.

Wichtig:

Diese Version von CatPutz darf nur in Verbindung mit einer CAT-Datenbank
ab Version 3.0 benutzt werden! Da sich das Format von einigen wenigen
Dateien geringfgig gendert hat, knnen bei der Verwendung von CatPutz
3.0 mit CAT 2.x Probleme mit einigen Dateien auftauchen.
Mit CAT 1.x darf diese CatPutz-Version in keinem Fall benutzt werden, das
hat eine komplette Zerstrung der Datenbank zur Folge. An dieser Stelle
verweisen wir auf den Teil mit der 'angewandten Dummheit' im
Einleitungsteil zu CAT.

Fehlermeldungen und andere Kommentare zu CatPutz gehren an folgende
Adresse:

Dirk Steins
Gleueler Strae 45
D-50931 Kln

EMail: Dirk Steins @ K2 (im MausNet)

Disclaimer
==========

  Ich, Dirk Steins, kann keine Haftung fr irgendwelche direkten oder
  indirekten Schden (einschlielich aber nicht beschrnkt auf
  materielle oder finanzielle Schden) bernehmen, die durch die
  Benutzung von CatPutz oder die Untauglichkeit von CatPutz fr einen
  bestimmten Zweck entstehen.

Es ist leider nicht mglich, fehlerfreie Programme zu schreiben, aber ich 
hoffe, da in CatPutz keine schwerwiegenden Fehler mehr enthalten sind.
Falls doch noch Fehler enthalten sind, bitte ich darum, diese per E-Mail an
mich zu schicken. Die Adresse steht am Beginn dieses Manuals.

Fast alle Soft- und Hardwarebezeichnungen, die in dieser Anleitung 
erwhnt werden, sind eingetragene Warenzeichen und sollten als solche 
betrachtet werden. Die Autoren dieser Anleitung folgen bei den 
Produktbezeichnungen im wesentlichen den Schreibweisen der Hersteller.

Alle Rechte vorbehalten. Kein Teil des Werkes (auch nicht auszugs-
weise) darf in irgendeiner Form (Druck, Fotokopie, Mikrofilm oder in
einem anderen Verfahren) ohne schriftliche Genehmigung der Autoren
reproduziert oder unter Verwendung elektronischer Systeme verarbei-
tet, vervielfltigt oder verbreitet werden.

Die Installation von CatPutz
============================

Am einfachsten ist es, wenn Sie die Dateien CATPUTZ.PRG, CATPUTZ.RSC
und CATPUTZ.HLP in das CAT-Verzeichnis kopieren. Wenn CatPutz keine
INF-Datei bergeben wird, erwartet es die Datei CAT.INF im selben
Verzeichnis. Eine INF-Datei wird fr den Betrieb von CatPutz zwingend
bentigt. Und daher ist es halt wirklich am einfachsten, wenn CatPutz im
Verzeichnis von CAT liegt.

Die Bedienung von CatPutz
=========================

CatPutz 3.0 hat in der Oberflche eine Rundumerneuerung bekommen. Statt
der Bedienung ber Dialoge und insbesondere der umstndlichen Gruppen-
auswahl wird CatPutz 3.0 komplett ber ein Hauptfenster und
mit schnen, multitasking-freundlichen Fensterdialogen bedient.

Die Bedienung der Dialoge entspricht der von CAT und sollte niemanden vor
ernsthafte Probleme stellen, daher sparen wir uns hier die Erluterung
davon einfach ein.

Das wichtigste Element in CatPutz 3.0 ist das Hauptfenster, in dem eine
Liste aller Gruppen dargestellt wird und in dem eine Iconleiste den
Aufruf smtlicher Funktionen ermglicht.


Eine genaue Erluterung der einzelnen Icons gibt es der Beschreibung
des Hauptfensters.

Bevor Sie Ihre Datenbank in den Schwitzkasten nehmen, sollten Sie
CatPutz richtig konfiguriert haben. Damit hoffentlich nichts
schiefgeht, habe ich einen Drei-Punkte-Plan aufgestellt:

1. allgemeine Einstellungen im Dialog Einstellungen vornehmen. 

2. Lschkriterien im Dialog Flags setzen. 

3. Nun knnen Sie in den Gruppen Nachrichten lschen


Die Menleiste
==============

Die Menleiste von CatPutz ist etwas spartanischer geworden, sie enthlt
nur noch zwei Eintrge.

CATPUTZ    Datei

Ich hoffe, das diese berwltigende Anzahl von Meneintrgen jetzt keinen
verwirrt. ;-)

Das CATPUTZ-Men
================

Wie auch in CAT finden Sie hier die Accessories und den Menpunkt zur
Programminformation.


ber CatPutz
============

Hier erscheint eine Programminformation, in der u.a. auch die aktu-
elle Versionsnummer von CatPutz zu finden ist (wichtig bei Fehler-
meldungen).


Das Datei-Men
==============

    Fenster ffnen      ^O
    Fenster schlieen   ^U
  ------------------------
    Parameter sichern   S
  ------------------------
    Beenden             ^Q

In diesem Menu sind die Funktionen enthalten, die man in CatPutz auch
ohne das Hauptfenster aufrufen kann. Es sind nur die Funktionen
anwhlbar, die auch gerade einen Sinn ergeben. Man kann also nicht
"Fenster schlieen" aufrufen, wenn kein Fenster geffnet ist.


Fenster ffnen
==============

Mit dieser Funktion wird das Hauptfenster von CatPutz geffnet. Wenn das
Fenster schon geffnet ist, dann ist diese Funktion nicht anwhlbar.

Fenster schlieen
=================

Mit dieser Funktion wird das Hauptfenster von CatPutz geschlossen. Wenn
das Fenster nicht geffnet ist, dann ist diese Funktion nicht anwhlbar.

Parameter sichern
=================

ber diese Funktion werden alle in CatPutz getroffenen Einstellungen
gesichert. Dies schliet auch den aktuellen Zustand des Fensters
(offen/geschlossen) ein und die Fensterposition.

Beenden
=======

Je nachdem, ob Sie mit CatPutz Unheil angerichtet haben oder nicht,
knnen Sie hier entweder frhlich oder zerknirscht das Programm ver-
lassen.

Die Online-Hilfe
================

CatPutz hat nun auch, wie CAT, eine echte Online-Hilfe eingebaut. Wo die
Routinen doch schon vorhanden waren, konnten sie in CatPutz ja auch
genutzt werden.

Wenn Sie in einem Dialog die HELP-Taste drcken, wird eine kontext-
sensitive Online-Hilfe aufgerufen. Sollten Sie den ST-GUIDE
installiert haben und die externe Hilfe ausgewhlt haben, so wird
dieser mit genau diesem Hypertext geffnet.

Sollten Sie den ST-Guide nicht installiert haben, so hat CatPutz auch eine
kleine Online-Hilfe eingebaut, die ebenfalls kontextsensitiv ist, aber
natrlich lngst nicht so schn wie der ST-Guide. Die richtigen

Das Hauptfenster
================

Dieses Fenster ist die Steuerzentrale von CatPutz 3.0. Hier whlen Sie
die Gruppen aus, fr die Sie etwas konfigurieren mchten, oder Sie
starten das Lschen in der Datenbank. Smtliche Konfigurationsdialoge
werden auch von hier aus aufgerufen.

Am oberen Rand des Fenster befindet sich eine Iconleiste, ber die die
einzelnen Funktionen aufgerufen werden. Wenn man mit der Maus ber die
einzelnen Icons fhrt, dann erscheint unterhalb der Icons ein Text, der
die Funktion beschreibt und auch das Tastaturkrzel fr die Funktion
enthlt.

Unterhalb der Iconleiste befindet sich die Gruppenliste komplett mit den
berschriften fr die einzelnen Spalten. Am Ende der Liste findet sich
noch ein Eintrag mit Gesamtinformationen ber alle Gruppen.

Eine Gruppe selektieren Sie, indem Sie einmal mit der Maus auf die Zeile
mit der Gruppe klicken. Um die Gruppe wieder zu deselektieren, klicken
Sie einfach noch einmal auf die Gruppe. Wenn Sie mehrere Gruppen
selektieren wollen, knnen Sie auch zwischen zwei Gruppen oder an den
linken Rand klicken und dann einen Rahmen aufziehen. Nach Loslassen der
Maustaste wird der Selektionsstatus jeder Gruppe in dem Rahmen
invertiert, als ob Sie jede Gruppe einzeln angeklickt htten.

Die einzelnen Icons haben folgende Funktion:

Nachrichten in Gruppen lschen
        Hiermit wird das Lschen in den selektierten Gruppen
        gestartet. Dabei werden die Lscheinstellungen fr diese
        Gruppe beachtet, oder, falls fr diese Gruppe keine speziellen
        Einstellungen vorgenommen wurden, die Defaulteinstellungen
        bernommen. Nach einer Sicherheitsabfrage wird der Lschvorgang
        gestartet, der Fortschritt wird dabei in einem
        Fortschrittsfenster angezeigt.
        Das Lschen kann jederzeit durch Drcken der Taste [ESC]
        abgebrochen werden. Nachdem eine Gruppe bearbeitet wurde, wird
        der Eintrag im Fenster fr diese Gruppe aktualisiert.

Gruppe lschen
        ber diese Funktion knnen Sie eine Gruppe komplett lschen.
        Die Gruppe wird komplett gelscht und aus allen Gruppenlisten
        von CAT entfernt. Diese Funktion kann aus technischen Grnden
        nur dann angewhlt werden, wenn nur eine einzelne Gruppe
        selektiert ist.

Alle selektieren
        ber dieses Icon werden alle Gruppen selektiert. Dies schliet
        die Gruppe fr die persnlichen Nachrichten nicht mit ein, damit
        man nicht versehentlich in dieser etwas lscht.

Selektion aufheben
        ber dieses Icon werden alle Gruppen deselektiert,
        auch die persnliche Gruppe.

INF-Datei laden
        ber dieses Icon kann man eine INF-Datei von CAT nachladen,
        damit man auch in einer anderen Datenbank aufrumen kann.
        Es werden dann alle Einstellungen fr diese andere Datenbank
        geladen.

Fenster speichern als
        Dieses Icon ruft die Exportfunktion von CatPutz auf. Damit kann
        man die Liste, die im Fenster dargestellt wird, als Textdatei
        an einem beliebigen Ort abspeichern. Es erscheint eine
        Dateiauswahlbox, in der man die Zieldatei angeben kann.

Fenster kopieren
        ber dieses Icon wird der Inhalt des Fenster auf das Clip-
        board geschrieben. Dies geschieht sowohl als Textdatei als
        auch als CSV-Datei. Bei der CSV-Datei wird eine Wertetabelle
        exportiert, in der die einzelnen Spalten durch Kommata getrennt
        sind. Mit Chart-Programmen, wie z.B. X-Act von SciLab, kann diese
        Statistik grafisch dargestellt werden.

Zeichensatz auswhlen
        ber dieses Symbol wird die Zeichensatzauswahl fr die Darstellung
        im Fenster aufgerufen. Die Zeichensatzauswahl entspricht der von
        CAT und sollte daher schon bekannt sein. Im Gegensatz zu frheren
        Versionen von CatPutz knnen jetzt alle Zeichenstze fr die
        Darstellung im Fenster benutzt werden. Siehe auch Kapitel 4.3.4.3.

Flags einstellen
        Hiermit rufen Sie die Lscheinstellung auf, siehe dazu auch
        Kapitel 4.3.4.1. Wenn eine Gruppe selektiert ist, dann werden
        die Defaulteinstellungen verndert. Wenn eine oder mehrere
        Gruppen selektiert sind, so werden die Einstellungen fr alle
        selektierten Gruppen verndert. Bei einer Gruppe wird der Dialog
        mit den aktuellen Einstellungen fr diese Gruppe gefllt, bei
        mehreren Gruppen ist das nicht mglich, daher wird der Dialog
        mit den vorgenommen Defaulteinstellungen gefllt.

Flags lschen
        Mittels dieses Icons werden die gruppenspezifischen Einstellungen
        fr alle selektierten Gruppen gelscht. Beim Lschen werden dann
        fr diese Gruppen die Defaulteinstellungen genommen.

Einstellungen
        Hierber wird der Optionen-Dialog von CatPutz aufgerufen. In
        diesem Dialog werden einige globale Einstellungen vorgenommen.
        Nheres dazu steht in Kapitel 4.3.4.2.

Einstellungen sichern
        ber diese Funktion werden smtliche Einstellungen gespeichert.
        Das sind alle Optionen, alle Lscheinstellungen fr alle Gruppen,
        der aktuelle Zeichensatz, die Fenstergre und -position, die
        Position innerhalb des Fensters und auch, ob das Fenster
        berhaupt offen ist.


Die Lschanzeige
================

In der Lschanzeige zeigt CatPutz den Fortschritt whrend des Lschens in
der aktuellen Gruppe an.


Lschflags einstellen
=====================

In diesem Dialog knnen Sie die Lschkriterien und das Lschverhalten
von CatPutz einstellen. Dabei knnen einerseits einige Flags aus CAT
beachtet werden und andererseits kann auch ein Datum angegeben
werden, bis zu dem gelscht werden soll.

Doch zunchst zu den Flags ...


In CAT ist es ja mglich, fr jede Message einen Haufen Flags
einzustellen. Die nun Folgenden werden in CatPutz zum selektiven
Lschen benutzt bzw. beachtet:

  Teillschung
  Totallschung
  Interessant
  Gefiltert
  Gelesen
  User-Flag 1
  User-Flag 2

Zustzlich gibt es in CatPutz noch das Pseudo-Flag <<Nicht gelesen>>.
Dieses Flag steht fr Nachrichten, bei denen das <<Gelesen>>-Flag
nicht gesetzt ist. Es wurde mit aufgenommen, um eine Negativ-
verknpfung herstellen zu knnen.

Die ersten beiden Flags haben eine feste Bedeutung und werden in
CatPutz wie folgt behandelt:

Teillschung
    Der Nachrichtentext wird gelscht, stattdessen kommt nur 
    ein kurzer Text, da diese Nachricht gelscht wurde. Das 
    ist dann interessant, wenn Sie bei einigen Nachrichten die 
    Kommentarverkettung zu einer frheren Nachricht beibehalten 
    wollen. Eine eventuelle Kommentarverkettung wird durch 
    Teillschung also nicht zerstrt.

    Im Gegensatz zu alten Versionen von CatPutz wird das ganze 
    nun auch so durchgefhrt, das CAT diese Nachrichten auch 
    wieder richtig in einem Outfile exportieren kann.

Totallschung
    Die Nachricht wird komplett gelscht und eine eventuell 
    vorhandene Kommentarverkettung zerstrt. Anschlieend ist 
    von der Nachricht keine einzige Spur mehr in der Datenbank 
    vorhanden.


WICHTIG:

Fr diese beiden Flags gilt auch die Beschrnkung durch <<Lschen bis
Datum>> nicht! Messages, bei denen eines dieser beiden Flags gesetzt
ist, werden immer behandelt!

Aber keine Regel ohne Ausnahme: Persnliche Nachrichten, die noch nicht
beantwortet wurden, werden von CatPutz nie gelscht! Dies gilt
auch fr die folgenden Einstellungen.

Fr die brigen fnf Flags (4) knnen Sie einzeln ber Popup-Menus
einstellen, wie diese Flags behandelt werden sollen. Dabei gibt es
fr jedes Flag vier Mglichkeiten der Behandlung:

Flag ignorieren = Whrend des Lschens wird dieses Flag nicht beachtet.

Nicht lschen = Eine Nachricht mit dem jeweiligen Flag wird nicht ge-
     gelscht.

Totallschung = Die Nachricht wird so behandelt, als ob das Flag
     <<Totallschung>> gesetzt wre.

Teillschung = Die Nachricht wird so behandelt, als ob das Flag
     <<Teillschung>> gesetzt wre.

Dabei besitzen die Flags bzw. die Aktionen verschiedene Priorittsstufen:

 1. Nicht lschen

 2. Totallschung

 3. Teillschung



Wenn also fr eine Message gleichzeitig verschiedene Flags gesetzt
sind und eines davon auf Nicht lschen gestellt wre, so wrde die
Nachricht nicht gelscht, auch wenn die anderen auf Teillschung oder
Totallschung stnden. Ebenfalls wird eine Nachricht total gelscht,
wenn sowohl die Flags Totallschung als auch Teillschung gesetzt
sind.

Aber auch diese Regel hat eine Ausnahme: Das Pseudo-Flag Nicht gelesen
ist von dieser Behandlung ausgenommen! Dieses Pseudo-Flag wird nur dann
beachtet, falls von allen anderen Flags vorher keine Entscheidung
ber die Behandlung der Nachricht getroffen wurde.

Zustzlich knnen Sie auch noch ein Datum eingeben, bis zu dem
maximal gelscht werden soll und ob dieses Datum beachtet werden
soll. Die Datumsangabe kann genauso flexibel eingegeben werden, wie
in der Box Nachrichten ab ... abrufen in CAT (siehe Kapitel 3.8.4.5).

Wenn Sie unter Flags die Standardeinstellung Flag ignorieren nicht
verndert haben, dann werden beim Lschen nur die Nachrichten
gelscht, die schon in CAT mit einem der beiden Lschflags versehen
wurden! Das dabei eingegebene Datum wird nur fr die anderen Flags
beachtet!


Noch ein paar Fragen ...
========================

Nun hat aber Kai Neahnung doch noch ein paar Fragen an Rainer Juhser:

Kai: Was ist denn der einfachste Fall?

Rainer: Du liest einfach ganz normal die Nachrichten und markierst nur
  die zu lschenden  mit den Flags Teillschung oder
  Totallschung . Nun kannst Du mit CatPutz ohne weitere
  Vorkehrungen die Nachrichten lschen, indem Du alle Flags auf
  <<Flags ignorieren>> stellst.

Kai: Das ist aber ganz schn umstndlich beim Lesen von Nachrichten.

Rainer: Stimmt. Dafr ist es auch 'Dummuser-fest'.

Kai: Danke! Wie ist das denn, wenn ich eine Datenbank haben will,
  die immer mindestens 14 Tage zurckreicht, ich aber mir das
  lstige Setzen der Flags ersparen will?

Rainer: Das ist mit CatPutz kein Problem. Stelle einfach das Datum im
  Dialog fr die Flags auf -14 und setze das Gelesen -Flag
  auf  Totallschung . Nun kannst Du CatPutz auf Deine
  Messagebase loslassen. Mchtest Du, da wichtige oder
  interessante Nachrichten nicht gelscht werden, so kannst Du
  diese vorher in CAT als Interessant markieren oder ihnen
  ein User-Flag verpassen. Dabei mssen im Flag-Dialog diese
  dann auf  Nicht lschen gestellt werden, sonst klappt's
  nmlich nicht.

Kai: Da es ja doch einige Laberkppe in der MAUS gibt, mchte ich
  die Nachrichten selektiv ber die Stichwortliste lesen. Die
  nicht gelesenen gelten somit automatisch immer als vogelfrei.
  Gibt's dafr auch 'ne Lsung?

Rainer: Na lego! Dirk hat an (fast) alles gedacht. Stelle einfach das
  Flag <<Nicht gelesen>> auf Totallschung und starte den
  eigentlichen Putz. Dabei werden allerdings auch die
  Nachrichten mit den normalen Lschflags gelscht."

Kai: Na prima. Gibt's auch Versicherungen, bei denen man sich gegen
  Fehlbedienungen in CatPutz versichern kann?

Rainer: Bis jetzt ist mir keine bekannt. Aber bestimmt kannst Du Dich
  auch dagegen versichern lassen.

Einstellungen
=============

In diesem Dialog knnen Sie allgemeine Einstellung vornehmen. Da
CatPutz beim Putz Platz fr temporre Dateien auf der Platte
bentigt, knnen Sie in dieser Box den Ort fr diese Dateien
festlegen. Dabei besteht zunchst einmal die Mglichkeit, diesen Pfad
durch einen Klick auf die Angabe zu ndern. Ist der Punkt Temporren
Pfad benutzen angekreutzt, versucht CatPutz, die Angabe aus den
Environmentvariablen TMP oder TMPDIR zu entnehmen. Der Schalter Pfad
aus INF-Datei veranlasst CatPutz dazu, den in der Datei CATPUTZ.INF
gespeicherten Pfad zu be- nutzen.


ber den Punkt <<Teilgelschte ohne Kommentar lschen>> knnen Sie
festlegen, ob in diesem Fall der Kommentar 'Diese Nachricht wurde
gelscht' in der Datenbank erscheint. Abgespeichert werden die
Einstellungen ber den entsprechenden Menpunkt im Datei - Men.

ber den Punkt <<Bearbeitete Gruppen deselektieren>> wird eingestellt, 
da die Gruppen, in denen das Lschen durchgefhrt wurde, nach dem 
Lschen deselektiert werden. Dadurch kann man den Fortschritt beim 
Lschen gut verfolgen.


Zeichensatz
===========


ber diesen Punkt knnen Sie den Zeichensatz des Statistikfensters
einstellen. Die Box wird dabei genauso bedient wie die aus CAT (5).

Die Kommandozeile
=================

Ab der Version 2.20 ist CatPutz auch ber die Kommandozeile
steuerbar. Dabei knnen Sie verschiedene Lschparameter angeben. Soll
zugleich auch noch eine INF- Datei als Parameter an CatPutz bergeben
werden, so mu diese aber der erste Parameter in der Kommandozeile
sein. Die Syntax:

 CATPUTZ.PRG [<Infodatei>] [-amdgq]

 _____________________________________________________________________
 Variablen in den Kommandozeilen
 =====================================================================
 Optionen  | Bedeutung
 ---------------------------------------------------------------------
 m<anzahl> | Setzt die maximale Anzahl der Nachrichten, die in einer
           | Gruppe brig bleiben sollen.
 ---------------------------------------------------------------------
 d<datum>  | Setzt ein Datum, bis zu dem alle Nachrichten gelscht
           | werden sollen. Das Format entspricht dem im CatPutz-
           | Dialog fr die Lschkriterien.
 ---------------------------------------------------------------------
 g<gruppe> | Spezifiziert eine Gruppe. Die persnliche Gruppe wird
           | dabei mit 'Persnliche' angesprochen. Die zu bearbei-
           | tenden Gruppen mssen einzeln angegeben werden.
 ---------------------------------------------------------------------
 a         | Spezifiziert alle Gruppen. Dabei wird die persnliche
           | Gruppe nicht mit eingeschlossen!
 ---------------------------------------------------------------------
 q         | Beendet CatPutz nach dem Vorgang automatisch (fr
           | Batch-Betrieb).
 _____________________________________________________________________

CatPutz kennt beim Lschen ber die Kommandozeile vier (6) verschie-
dene Modi:

  Lschen aller Nachrichten bis zu einem Datum. Das ist dann der
   Fall, wenn vor einer Gruppenangabe nur der Schalter -d<datum>
   mit einem gltigen Datum angegeben wird.

  Lschen aller Nachrichten bis auf eine bestimmte Anzahl von
   Nachrichten.
   Das erreichen Sie, wenn Sie vor einer Gruppenangabe nur den
   Schalter -m<anzahl> angeben. Gltige Werte gehen von 1 bis 65535.

   Wichtig:

   Es gibt dabei einen Sonderfall.Bei einer Angabe von -m0 wird eine
   Gruppe komplett gelscht!

  Lschen aller Nachrichten, die lter als das angegebene Datum
   sind, wobei nur eine maximale Anzahl an Nachrichten
   brigbleiben drfen. Dieser Modus wird dann gewhlt, wenn Sie
   vor einer Gruppenangabe sowohl -d<datum> als auch -m<anzahl>
   angeben.

  Wenn vor einer Gruppenangabe keiner keiner der Schalter
   -d<datum> und -m<anzahl> auftaucht, werden fr diese Gruppe die
   in CatPutz eingestellten Lschkriterien benutzt.


Sie knnen beliebig viele Parameter angeben. Diese werden in der
Reihe ihres Auftretens in der Kommandozeile abgearbeitet. Die
Einstellungen mit -d<datum> und -m<anzahl> gelten fr alle folgenden
Gruppenangaben, bis eine erneute Angabe fr -d<datum> oder -m<anzahl>
erfolgt.

Da die Kommandozeilen ziemlich lang werden knne, wird von CatPutz
das ArgV-Verfahren untersttzt. Eine vernnftige Shell (z.B. die
Mupfel) sollte keine Probleme damit haben.


Immer wieder gerne gesehen ... Beispiele
========================================

Beispiel 1:

catputz -d1.10. -gAtari.Soft -gAtari.Talk -gSysops

Dieser Aufruf lscht in den Gruppen 'Atari.Soft', 'Atari.Talk' und
'Sysops' alle Nachrichten, die vor dem 1.10. liegen.

Beispiel 2:

catputz -m4000 -gkoeln -d1.1. -gPersnliche

Bei diesem Aufruf werden alle Mails bis auf 4000 in der Gruppe
'KOELN' gelscht. Danach werden dann alle Mails vor dem 1.1. in der
Gruppe 'Persnliche' gelscht.

Beispiel 3:

catputz -gAtari.Soft -gMaus -m2000 -d1.9. -gMausTausch -gMusik -q

Bei diesem Aufruf wird in den Gruppen 'Atari.Soft' und 'Maus' so
gelscht, wie Sie es in CatPutz fr diese Gruppen (oder auch global)
eingestellt haben. Danach werden in den Gruppen 'MausTausch' und
'Musik' alle Nachrichten gelscht, die vor dem 1.9. kamen, wobei
maximal 2000 Nachrichten in den Gruppen brigbleiben. Danach wird
CatPutz beendet.

Beispiel 4:

catputz -d1.10. -m100 -gMaus -d1.1. -gcat -m42 -gKoeln

Diese Zeile lscht in der Gruppe 'Maus' alle Nachrichten vor dem
1.10. und lsst maximal 100 Nachrichten in der Gruppe brig. Danach
werden in der Gruppe 'CAT' alle Nachrichten vor dem 1.1. gelscht.
Abschliessend wird die Gruppe 'Koeln' auf 42 Nachrichten reduziert.

Beispiel 5:

catputz -a -gPersnliche

Diese Kommandozeile lscht in allen Gruppen nach den Default-
einstellungen, die in der Datei CATPUTZ.CFG gespeichert sind.

Die Konfigurationsvariablen
===========================

Ebenso wie CAT speichert CatPutz seine Einstellungen in einer
Konfigurationsdatei. Fr CatPutz heit diese Datei CATPUTZ.CFG und liegt
im Datenbankordner der entsprechenden Datenbank. CatPutz hat dadurch fr
jede Datenbank unterschiedliche Einstellungen.
Dabei wird ein lesbares und mit einem Editor nderbares Format benutzt.In
der Datei werden einfach den Variablen bestimmte Werte nach Pascal- bzw.
Modula-Konvention zugewiesen. Die Variablennamen sind casesensitiv, es
wird also zwischen Gross- und Kleinschreibung unterschieden.

Beispiel:

StatWindowOpen := TRUE;

Die Variablen reprsentieren in fast allen Fllen Punkte aus den
Konfigurationsdialogen. Sie werden daher an dieser Stelle auch nicht
mehr so ausfhrlich beschrieben. Zur Orientierungshilfe wurden die
Variablen nach den Dialogen sortiert.

  _________________________________________________________________________
  Variable                 Wertebereich   Beschreibung
  =========================================================================
  StatWindowRect        |  {x,y,w,h}    | Position des Hauptfensters
  StatFont              |  Zahlenwert   | Font des Hauptfensters
  StatFontSize          |  Zahlenwert   | Fontgre des Hauptfensters
  StatWindowStart       |  Zahlenwert   | Nummer der ersten Zeile im
                        |               | Hauptfenster
  StatWindowOpen        |  TRUE/FALSE   | TRUE, wenn das Hauptfenster
                        |               | offen ist
  StatWindowLineDist    |  Zahlenwert   | Abstand in Pixeln zwischen
                        |               | zwei Zeilen. Default: 2
  StatWindowLeftOffset  |  Zahlenwert   | Abstand in Pixeln vom linken
                        |               | Rand bis zur ersten Spalte
                        |               | Default: 8 Pixel
  UseTempPath           |  TRUE/FALSE   | Temporren Pfad benutzen
  UseOwnTempPath        |  TRUE/FALSE   | eingestellten Pfad benutzen
  TmpDir                |  String       | Eigener temporrer Pfad
  DeleteMsgWithoutComment| TRUE/FALSE   | Teilgelscht Nachrichten ohne
                        |               | Kommentar auch lschen
  Default.delInteresting|    0..3       | Defaulteinstellung fr
                        |               | Interessant-Flag
  Default.delUserflag1  |    0..3       | Defaulteinstellung fr
                        |               | Userflag 1
  Default.delUserflag2  |    0..3       | Defaulteinstellung fr
                        |               | Userflag 2
  Default.delRead       |    0..3       | Defaulteinstellung fr
                        |               | Gelesen-Flag
  Default.delFiltered   |    0..3       | Defaulteinstellung fr
                        |               | Gefiltert-Flag
  Default.delUnread     |    0..3       | Defaulteinstellung fr
                        |               | ungelesene Nachrichten
  Default.deleteByDate  |  TRUE/FALSE   | Defaulteinstellung fr
                        |               | Lschen bis Datum
  Default.deleteDate    |   String      | Defaulteinstellung fr
                        |               | Lschdatum
  CatPutzHelpText       |   String      | Name des Hypertextes fr die
                        |               | Hilfe. Default: CATPUTZ.HYP
  DisplayFormat         |   String      | Einstellung fr die Anzeige
                        |               | Siehe Anzeigeformat


Das Anzeigeformat
=================

In CatPutz 3.0 ist die Anzeige hnlich wie in CAT in der Stichwortliste
frei konfigurierbar. Es wird das Format der Anzeige ber eine Variable
eingestellt, in der einzelne Tokens fr die einzelnen Elemente in den
Zeilen stehen. Hinter den Tokens steht in Klammern die Breite fr diesen
Eintrag.

Folgende Tokens existieren:

 ====================================================
 Token |    Bedeutung
 ====================================================
   G   |    Gruppe. Bei einer Weite von -1 wird die
       |    Lnge des lngsten Namens genommen
   B   |    Anzahl beschdigte Nachrichten
   D   |    Anzahl totalgelschter Nachrichten
   T   |    Anzahl teilgelschter Nachrichten
   M   |    Anzahl Nachrichten vorher
   N   |    Anzahl Nachrichten nachher
   V   |    Kilobytes vorher
   W   |    Kilobytes nachher
   X   |    Kilobytes gelscht
 ====================================================

Das Defaultformat entspricht folgender Formatzeile:

G(-1),M(12),V(10),D(12),T(12),B(12),N(12),W(10),X(10)

History
=======

(erst ab Version 1.25)

24.05.92  1.26
Version fr gendertes GRUPPEN.POS in neuer Beta von CAT.

19.10.92  1.27
Angepat an Datenbank von CAT 2.0

1.11.92   1.28
Auch berprfung des Message- und Statusdatums eingebaut, so da auch dabei
danach keine Fehler mehr in der Datenbank sein drfen. Die durch den 
Messagecheck gelschten Nachrichten werden jetzt mit bei den totalgelschten 
Nachrichten angezeigt!

2.11.92   1.28
Anzeige der Differenz-Kilobytes eingebaut (fr Peter Veith @ BN). 

9.11.92   1.29 
Lschen von einzelnen Gruppen ber CatPutz eingebaut.

28.12.92  1.30 
Ausgabe von Statistik als Textfile und als CSV auf Clipboard eingebaut,
nachladen von CAT.INFs eingebaut. 
Dialogbox bei Gruppenlschen verbessert und es wird mit Gruppennamen
abgefragt, ob die Gruppe gelscht werden soll. 
Scannen der Gruppeninformationen beschleunigt.

21.01.93  1.31 
CatPutz strzt nicht mehr ab, wenn kein GRUPPEN.POS vorhanden ist. Das wird 
dann einfach ignoriert, da es fr CatPutz nicht so wichtig ist.

07.02.93  1.32 
Nach dem Neuladen einer CAT.INF Datei wurde die Liste im Fenster nicht neu 
dargestellt, es wurde nur die Summe richtig angezeigt. 

25.3.93   2.0
Versionsnummer gendert fr endgltige Distribution

12.4.93   2.01 
Bug mit langen Gruppennamen behoben. CatPutz beachtet jetzt die Dialog-
einstellungen aus dem CPX richtig

7.6.93    2.09 
Gruppenweise Konfiguration eingebaut

2.7.93    2.10
Diese Version freigegeben

26.9.93   2.11   
Anfang der Umstellung auf weitere CAT-Module

30.9.93   2.15
CatPutz luft mit CATGROUP.*, lscht jetzt richtig, Lschanzeige im Fenster
und parallel unter MTOS und Mag!X

2.10.93   2.15
CatPutz prft, ob CAT oder CatPutz schon aktiv sind und verweigert dann
den Start 

4.10.93   2.16
Einbau der Kommandozeilensteuerung

7.10.93   2.16        
Beim Lschen ber die Kommandozeile wurden auch Nachrichten mit dem 
Interessant-Flag glscht. Das sollte nicht der Fall sein, deshalb wurde das 
gendert. Allerdings kann es dadurch passieren, da beim Lschen mit 
Mengenangabe die Zielmenge berschritten wird

14.10.93 2.17
Auswertung der Fehlercodes nach Fread/Fwrite war falsch 

21.10.93 2.17        
Gruppennamen sind wieder Case-Insensitiv in der CFG-Datei. Das Datum in der 
Konfigurationsbox ist nicht mehr ab und zu uninitialisiert. 

29.10.93 2.18        
Mauszeiger ist nur noch dann ein Ball, wenn ein eigenes Fenster das 
Topwindow ist.

1.11.93    2.20
Diese Version freigegeben

18.11.93   2.22
Beim Speichern der Statistik war ein Filename nicht initialisiert. Dies konnte
zu Abstrzen fhren.
wind_update (check&Set) wird nur noch unter MTOS oder Mag!X benutzt.
Kommandozeilenparameter -a fr alle Gruppen eingebaut. 
Der Gruppenname sollte jetzt immer richtig gezeichnet werden, auch wenn
beim Gruppenwechsel die Ausgabe gesperrt war.

28.11.93  2.23
In der relativen Datumsberechnung war durch einen Typnderung auf einen Unter-
bereichstyp ein Bug drin, der bei einigen Berechnungen zu vollkommen fehlerhaften
Daten fhrte.
In der Statistikausgabe fr die einzelnen Zeilen waren teilweise in den Werten
Fehler enthalten.
Jetzt sollte CatPutz wirklich unter Mag!X 1.11 laufen, da fehlte eine Abfrage.

7.12.93  2.24
Es wird jetzt immer getestet, ob der eingestellte TMP-Pfad existiert. Wenn 
das nicht der Fall ist, dann wird der Databasepfad genommen. 
Ein paar weitere Sicherheitsabfragen beim Dateihandling eingebaut.

7.7.94  2.26
Das Fenster wird auch im Batchmodus nach jeder Gruppe refresht.
CatPutz-Logo gendert. REQ-File wird am Ende geschlossen.
Bei wenig freiem Speicher konnte es passieren, da CATPUTZ Speicherblcke
zerstrt hat und den Rechner abgeschossen hat. Das trat dann auf, wenn
der zu schreibende Block mehr als doppelt so gro war wie der Writebuffer.
Wenn das Lschdatum grer als das Tagesdatum ist, kommt ein Alert.

17.7.94     2.27
Beim Lschen ber die Kommandozeile mit -a kommt es nicht mehr zu einer 
Endlosschleife in den Gruppen.

21.6.96     2.28
Wenn die TAB-Dateien nicht gepuffert werden knnen, dann schrieb CatPutz
diese nicht richtig, da in das falsche Filehandle geschrieben wurde.

24.6.96     2.30 
Neue Oberflche so gut wie fertig. Alle Buttons drin, alle Buttons 
funktionieren, Fly-Over-Help ist drin. Es fehlt noch:
  - Richtiges Auslesen der CATPUTZ.INF bzgl. Fensterposition und Status
  - ggf. ein paar WindUdpate-Checks, es knnte sein, das momentan whrend
    des Lschens andere Programme blockiert sind
  - Umstellung von Fsfirst/Fsnext auf Mint-Calls (Dopendir etc.)

3.7.96      2.30 
Feststellen der Gruppengren umgestellt bzw. erweitert um Mint-Calls.
Auerdem Algorithmus komplett umgebaut, das war viel zu umstndlich, es
wurde dabei fr jede Gruppe im Directory gelesen. Jetzt wird das Directory
gelesen und dann die Gre festgestellt.

10.7.96     2.40 
Alle fehlenden Funktionen eingebaut, jetzt funktioniert auch das Sichern und
Wiederherstellen des Fensterstatus wieder wie in CatPutz 2.27.
Auerdem noch ein paar kleine Bugs behoben.
Diese Version geht jetzt in den Betatest. CatPutz braucht jetzt mindestens
einen 80 kB Block beim Lschen, da der Messagetext in neueren CAT-Versionen
ja grer sein kann, und die Message mu am Stck kopiert werden knnen.
Eine Umstellung da ist etwas komplizierter, daher lasse ich das lieber.
Beim Lschen wird jetzt zur Feststellung von kaputten Nachrichten nicht
mehr die Nachrichtengre geprft, da dies nicht mehr mglich ist.
Diese Anleitung mu noch angepat werden.

3.8.96     2.41 
CatPutz scannt auch unter normalem TOS ohne Mint-Funktionen die Dateien 
fr die Statistik am Anfang wieder richtig.
Zurckgestellte und Nicht beantwortete persnliche Nachrichten werden
von CatPutz jetzt gar nicht mehr gelscht (nie!).

19.8.96    2.42 
Memory Leak behoben, das zu Speicherzersplitterung fhrte. 
Bei mir nicht nachvollziehbarer Absturz am Programmende hoffentlich 
umgangen. 

2.9.96     2.43 
Einlesen der Gruppendaten beschleunigt durch Umstellung auf Dxreaddir und
zustzlichen Test bei Suche nach der Gruppe in der Liste.
Hilfe aus CAT eingebaut. Hilfetext fehlt noch.

6.9.96    2.44 
Fehler bei Einlesen der Gruppendaten unter normalem TOS beseitigt, da 
stimmte die Statistik mal wieder nicht, da die Dateinamen nicht 
richtig verglichen wurden.
Menus umgestellt auf eigene Nicelines, dadurch hoffentlich Fehler 
mit Deallocate am Programmende unter Single-TOS behoben.

9.9.96   2.99 
Versionsnummer upgedatet, letzte Testversion
Ascii-Anleitung erstellt, Hypertext-Anleitung aktualisiert, interne Hilfe
erstellt

15.9.96 3.0
Version 3.0 freigegeben

19.10.96 3.01
 - FIX: CatPutz strzt nicht mehr ab beim Nachladen einer Infodatei.
 - FIX: Einstellige Anzeigeformate werden richtig ausgewertet.

16.12.96 3.02
 - FIX: Beim Lesen einer INF-Datei werden auch die Fenstereinstellungen dafr
   bernommen.
 - FIX: Beim Lschen wird auch jedesmal nach einer Gruppe der Summeneintrag
   neu gezeichnet.
 - NEW: Neuer Schalter: Bearbeite Gruppen deselektieren. Gruppen werden 
   nach dem Lschen in dieser Gruppe deselektiert.
 - FIX: Beim Lschen ber die Kommandozeile wird der Summeneintrag auch 
   aktualisiert.
 - FIX: Kein 16-Bit berlauf mehr beim Lschen von groen Nachrichten, bei 
   denen Text und Header zusammen ber 64 KB gro waren.
 - NEW: Ebenso wie bei CAT gibt es die neue Configvariable "AlertsInWindow", 
   Default FALSE. Wenn diese auf TRUE gesetzt ist, dann werden die Alerts in 
   Fenstern dargestellt, sonst nur als normale Dialoge. Default ist FALSE! 
   Daher werden nach einem Update die Alerts erstmal wieder als normale 
   Dialoge dargestellt. Grund: Durch die Alerts in Fenstern gab es einige 
   Reentranz-Probleme und die Darstellung wurde durch die stndigen Redraws 
   und Menuzeilenwechsel auch langsamer.
 - FIX: Konfigurationsvariable MiNTDomain wieder eingebaut, siehe CAT-
   Anleitung

12.02.97  3.02
 - FIX: Lschen von Einstellungen fr Gruppen funktionierte nicht. Grund:
   Es war gar nicht eingebaut ;-(

10.08.97  3.02
 - FIX: Bei der Gesamtanzahl der teil-oder totalgelschten Nachrichten konnte 
   es zu einem 16 Bit berlauf kommen, da das unsinnigerweise nur ein CARDINAL
   war. Gendert auf LONGCARD.
