DEFINITION MODULE PutzAction;

FROM SYSTEM IMPORT ADDRESS;

(* In diesem Modul laufen die Ausgaben des Putzes zusammen
 * Es wird ein Dialog in einem Fenster dargestellt, und
 * die Ausgaben werden ber die Rechteckliste mit den 
 * get&set-Modus von wind_update gemacht
 *)

PROCEDURE InitActionBox ();
(* Initialisiert die Box, bringt das Fenster auf den Bildschirm
 *)

PROCEDURE ReInitActionBox (REF grName : ARRAY OF CHAR; msgCount : LONGCARD);
(* Init der Action-Box: Es werden alle notwendigen festen Strings berechnet,
 * die variablen Strings werden gelscht und die Box wird gezeichnet.
 * Der Prozentbalken wird auf 0% gesetzt und auch gezeichnet
 *)

PROCEDURE BeginNextPass (mode: INTEGER);
(* Reinitialisiert die Box nochmals, stellt Zhler wieder auf 0, 
 * und zeigt nchsten Modus an.
 *)

PROCEDURE ShowBuffStatus (tabBuff, parBuff, datBuff : BOOLEAN);
(* Zeigt den Pufferungsstatus in der Box an
 *)

PROCEDURE ReleaseActionBox();
(* Gibt die Boxu nd das Fenster wieder frei
 *)

PROCEDURE TellAction (actMode : INTEGER; msgCount : LONGCARD): BOOLEAN;
(* Hauptprozedur, zeigt neuen Stand im Fenster an
 *)

PROCEDURE InitModule (tree: ADDRESS);
(* Mu am Anfang aufgerufen werden, damit das Modul die Adresse 
 * des Baumes hat
 *)

END PutzAction.
